#
# binhost.mk is used to generate a statically linked ELF executable
# Peludo Module.
#
# Maybe you want to include objhost.mk too.
#
# BIN=			Name of the executable ELF file to generate.
# 			MANDATORY variable.
#
# OBJS_ALL=	 	List of object files.
# 			(defined automatically by objhost.mk).
#
# STATIC_ARADD=	 	List of additional .a libraries to include into
# 			the generated file.
#
# STATIC_CRT0=		Fullpath of crt0[_debug].o.
# 			(Defined automatically by base.mk).
#
ifdef BIN

CLEANFILES+=	${BIN}

${BIN}: ${STATIC_CRT0} ${OBJS_ALL} ${STATIC_ARADD}
	${LD} ${STATIC_LDFLAGS} -o $@ $+
ifneq (${PLDEBUG}, yes)
	${STRIP} -s -R .comment $@
endif

binhost: ${BIN}

else
PLERROR+=	"BIN not defined."
endif
