#
# bintarget.mk is used to generate the MAIN peludo module.
# The MAIN peludo module exports the main() function.
#
# This file IS NOT used to generate common peludo modules,
# use libtarget.mk for that.
#
# Maybe you want to include objtarget.mk too.
#
# MOD=			Name of the .pld module file to generate.
# 			MANDATORY variable.
#
# BIN=			Name of the .elf file to generate.
# 			(If you define MOD but not BIN a default
# 			BIN will be generated as ${MOD}.elf).
#
# OBJS_ALL=	 	List of object files.
# 			(defined automatically by objtarget.mk).
#
# ARADD=	 	List of additional .a libraries to include into
# 			the generated file.
#
# LDADD=		List of libraries to link dynamically (.so)
#
# CRT0=			Fullpath of plcrt0[_debug].o.
# 			(Defined automatically by base.mk).
#
ifdef MOD

ifdef BIN
_BIN=			${BIN}
else
_BIN=			${MOD}.elf
endif

CLEANFILES+=		${MOD} ${_BIN}

${_BIN}: ${CRT0} ${OBJS_ALL}
	${LD} ${LDFLAGS} -o $@ $+ ${ARADD} ${LDADD}

${MOD}: ${_BIN}
	${ELF2PLD} ${ELF2PLD_FLAGS} -p ${notdir $@} $< $@

else
PLERROR+=	"MOD not defined."
endif

