
.text
.global ground


#if defined(PL_linux_i386)

/*************
 * Linux-i386
 *************/
ground:
	pusha
	movl	$1, %ebx		// stdout
	call	sigue

.asciz	"Hello Ground!\n"

.align 4				// to see "sigue" using objdump -D

sigue:	popl	%ecx			// buffer
	movl	$13, %edx		// size
	movl	$4 , %eax		// write(2)
	int	$0x80
	popa
	xorl	%eax, %eax
	ret


/*************
 * Win32-i386
 *************/
#elif defined(PL_win32_i386)
#error "WIN32 broken. Fix resolve_dll"

/*
int ground(long pld, long resolve_dll, long resolve_symbol,
	   long resolve_symbol_any)
*/
ground:
	pushl	%ebp
	movl	%esp, %ebp

	/*
	 * resolve_dll("kernel32.dll");
	 */
	call	_01
.asciz	"kernel32.dll"
.align 4
_01:	movl	12(%ebp), %eax
	call	*%eax			//resolve_dll()
	addl	$4, %esp
	orl	%eax, %eax
	jz	ground_bad

	/*
	 * resolve_symbol(k32base, "LoadLibraryA");
	 */
	call	_02
.asciz	"LoadLibraryA"
.align 4
_02:	pushl	%eax			// EAX = Base Address of kernel32.dll
	movl	16(%ebp), %eax
	call	*%eax			// resolve_symbol()
	addl	$8, %esp
	orl	%eax, %eax
	jz	ground_bad

	/*
	 * LoadLibraryA("user32.dll");
	 */
	call	_03
.asciz	"user32.dll"
.align 4
_03:	call	*%eax			// EAX = LoadLibraryA
	orl	%eax, %eax
	jz	ground_bad

	/*
	 * resolve_symbol(user32base, "MessageBoxA");
	 */
	call	_04
.asciz	"MessageBoxA"
.align 4
_04:	pushl	%eax			// EAX = Base Address fo user32.dll
	movl	16(%ebp), %eax
	call	*%eax			// resolve_symbol()
	addl	$8, %esp
	orl	%eax, %eax
	jz	ground_bad

	/*
	 * MessageBoxA(NULL, "Hello Ground!", "Peludo Rocks", MB_OK);
	 */
#define MB_OK	$0
	pushl	MB_OK
	call	__01
.asciz	"Peludo Rocks"
.align 4
__01:	call	__02
.asciz	"Hello Ground!"
.align 4
__02:	pushl	$0
	call	*%eax			// MessageBoxA()

	xorl	%eax, %eax

ground_end:
	popl	%ebp
	ret

ground_bad:
	orl	-1, %eax
	jmp	ground_end

#else
#error "PLATFORM NOT SUPPORTED"
#endif
