/*
 * XXX CURRENT IMPLEMENTATION OF ELF2PLD can't import from
 *     non native libraries when --native is specicifed
 */
#include <plc.h>

static char *m2 = "eaea pepe";

void PLEXPORT print(const char *str);

char *mensajito PLEXPORT = "hola mundo";

int bss_var PLEXPORT;


int PLEXPORT
strlen(const char *str)
{
	return plstrlen(str);
}


char PLEXPORT *
strcpy(char *dst, const char *src)
{
	return plstrcpy(dst, src);
}


char PLEXPORT *
strcat(char *dst, const char *src)
{
	return plstrcat(dst, src);
}


#ifndef PLOS_win32
void PLEXPORT
print(const char *str)
{
	plprint(str);
}

#else
extern int __attribute__((stdcall)) MessageBoxA(void *, const char *,
    const char *, int);

void PLEXPORT
print(const char *str)
{
#define MB_OK	0
	//asm("int3");
	(void)MessageBoxA(NULL, str, "Flying Peludos", MB_OK);
}

#endif /* !PLARCH_win32 */


void PLEXPORT
mensajito2()
{
	char *buf;
	PLSTATUS st;
	long err;

	print("\tCalling plmm_malloc()... ");
	st = plmm_malloc(&err, (long *)&buf, 1024);
	if (st != PLSTATUS_SUCCESS) {
		plprint("error during plmm_malloc(), errno=%d!\n", err);
	} else {
		plstrcpy(buf, "\n\tCalling kstrcat()...\n");
		plstrcat(buf, "\tm2=<");
		plsys_memmove((uint8*)buf + strlen(buf), (uint8 *)m2,
		    strlen(m2)+1);
		plstrcat(buf, ">\n");
		plstrcat(buf, "\tCalling mm_free()...\n");

		print(buf);

		st = plmm_free(&err, (long)buf);
		if (st != PLSTATUS_SUCCESS) {
			plprint("error during plmm_free(), errno=%d\n", err);
		}
	}

	print("Assigning 1 to bss_var...\n");
	bss_var = 1;
}


int PLEXPORT
_init()
{
	print("Hello, I'm _init() from libmensajito\n");
	mensajito2();

	return 0;
}

