/**
 * @file src/include/pldef.h
 * Peludo Definitions.
 */
#ifndef PLDEF_H
#define PLDEF_H


/**
 * Peludo Memory Flags
 */
typedef enum _PLMFLAGS {
	PLMFLAGS_X = 0x01,
	PLMFLAGS_R = 0x02,
	PLMFLAGS_W = 0x04
} PLMFLAGS;


/**
 * Peludo Status Codes.
 */
typedef enum _PLSTATUS {
        PLSTATUS_SUCCESS = 0,
	PLSTATUS_EOF = 80000001,
	PLSTATUS_FAILED,
	PLSTATUS_INVALID,
	PLSTATUS_INVALID_ADDRESS,
        PLSTATUS_NOT_IMPLEMENTED,
	PLSTATUS_MALFORMED_TABLE,
        PLSTATUS_MODULE_NAME_DUPLICATED,
	PLSTATUS_MODULE_NOT_FOUND,
        PLSTATUS_OUT_OF_MEMORY,
        PLSTATUS_SECTION_NOT_FOUND,
        PLSTATUS_SYMBOL_NOT_FOUND,
	PLSTATUS_TIMEOUT,
	PLSTATUS_TRY_AGAIN,
	PLSTATUS_INTERNAL_ERROR
} PLSTATUS;


#endif	/* PLDEF_H */
