/**
 * @file include/std/arpa/inet.h
 * Peludo LibC - arpa/inet.h
 */
#ifndef __ARPA_INET_H__
#define __ARPA_INET_H__


#include <plc.h>


int PLEXPORT inet_pton(int, const char *, void *);
int PLEXPORT inet_pton4(const char *src, unsigned char *dst);


inline static int __attribute__((always_inline))
inet_aton(const char *cp, struct in_addr *inp)
{
	return inet_pton4(cp, (unsigned char *)inp);
}


inline static uint32 __attribute__((always_inline))
ntohl(uint32 n)
{
	return PLN32H(n);
}


inline static uint32 __attribute__((always_inline))
htonl(uint32 n)
{
	return PLN32H(n);
}


inline static uint16 __attribute__((always_inline))
ntohs(uint16 n)
{
	return PLN16H(n);
}


inline static uint16 __attribute__((always_inline))
htons(uint16 n)
{
	return PLN16H(n);
}


#endif	/* __ARPA_INET_H__ */
