/**
 * @file include/std/assert.h
 * Peludo LibC - assert.h
 */
#ifndef __ASSERT_H__
#define __ASSERT_H__

#include <plc.h>
#include <pllog.h>


#ifdef PLDEBUG

#define assert(exp)	do {						\
	if (!(exp)) {							\
		pldebug("%s at line %d: Assert failed. Aborting.\n",	\
		    __FUNCTION__, __LINE__);				\
		plsys_exit(-1);						\
		/* NOTREACHED */					\
	}								\
} while (0)

#else

#define assert(exp)

#endif	/* PLDEBUG */


#endif	/* __ASSERT_H__ */
