/**
 * @file include/std/dirent.h
 * Peludo LibC - dirent.h
 */
#ifndef __DIRENT_H__
#define __DIRENT_H__

#include <plc.h>


typedef long DIR;


static inline DIR __attribute__((always_inline)) *
opendir(const char *path)
{
	long handle;

	switch (plsys_opendir(&handle, path)) {
	case PLSTATUS_SUCCESS:
		return ((DIR *)handle);

	case PLSTATUS_INVALID:
		errno = EINVAL;
		break;

	default:;
	}

	return NULL;
}


static inline int __attribute__((always_inline))
closedir(DIR *dir)
{
	plsys_closedir((long)dir);
	return 0;
}


static inline struct dirent __attribute__((always_inline)) *
readdir(DIR *dir)
{
	struct dirent *de;

	return ((plsys_readdir((long)dir, &de) == PLSTATUS_SUCCESS) ?
	    de : NULL);
}


#endif	/* __DIRENT_H__ */
