/**
 * @file include/std/limits.h
 * Peludo LibC - limits.h
 */
#ifndef __LIMITS_H__
#define __LIMITS_H__

#include <plarchdef.h>

#define CHAR_BIT	8

#define USHRT_MAX	(65535)
#define SHRT_MAX	(32767)
#define SHRT_MIN	(-32768)

#define UINT_MAX	(4294967295U)
#define INT_MAX		(2147483647)
#define INT_MIN		(-INT_MAX - 1)

#if defined(PLARCH_x86_64)
#define ULONG_MAX	(18446744073709551615UL)
#define LONG_MAX	(9223372036854775807L)
#else
#define ULONG_MAX	(4294967295UL)
#define LONG_MAX	(2147483647L)
#endif

#define LONG_MIN	(-LONG_MAX - 1L)

#define ULLONG_MAX	(18446744073709551615ULL)
#define LLONG_MAX	(9223372036854775807LL)
#define LLONG_MIN	(-LLONG_MAX - 1LL)

#define PATH_MAX	4096

#endif	/* __LIMITS_H__ */
