/**
 * @file include/std/semaphore.h
 * Peludo Threads - Semaphores.
 * @see http://www.opengroup.org/onlinepubs/007908775/xsh/semaphore.h.html
 */
#ifndef __SEMAPHORE_H__
#define __SEMAPHORE_H__

#include <plspinlock.h>

#define _POSIX_SEMAPHORES

struct _sem {
	PLOCK	sem_lock;
	long	sem_wcount;
	long	sem_value;
};

typedef struct _sem * sem_t;

#define SEM_FAILED	((sem_t *)0)
#define SEM_VALUE_MAX	(2147483647)

int	 sem_init(sem_t *, int, unsigned int);
int	 sem_destroy(sem_t *);
int	 sem_getvalue(sem_t *, int *);
int	 sem_post(sem_t *);
int	 sem_trywait(sem_t *);
int	 sem_wait(sem_t *);

/*
 * Not implemented.
 */
sem_t	*sem_open(const char *, int, ...);
int	 sem_close(sem_t *);
int	 sem_unlink(const char *);

#endif	/* __SEMAPHORE_H__ */
