/**
 * @file include/std/sys/stat.h
 * Peludo LibC - sys/stat.h
 */
#ifndef __SYS_STAT_H__
#define __SYS_STAT_H__

#include <plc.h>


static inline int __attribute__((always_inline))
chmod(const char *path, mode_t mode)
{
	return ((plsys_chmod(path, (long)mode) == PLSTATUS_SUCCESS) ? 0 : -1);
}


static inline int __attribute__((always_inline))
mkdir(const char *path, mode_t mode)
{
	return ((plsys_mkdir(path, (long)mode) == PLSTATUS_SUCCESS) ? 0 : -1);
}


static inline int __attribute__((always_inline))
fstat(int fd, struct stat *buf)
{
	return ((plsys_fstat((long)fd, buf) == PLSTATUS_SUCCESS) ? 0 : -1);
}


static inline int __attribute__((always_inline))
lstat(const char *path, struct stat *buf)
{
	return ((plsys_lstat(path, buf) == PLSTATUS_SUCCESS) ? 0 : -1);
}


static inline int __attribute__((always_inline))
stat(const char *path, struct stat *buf)
{
	return ((plsys_stat(path, buf) == PLSTATUS_SUCCESS) ? 0 : -1);
}


#endif	/* __SYS_STAT_H__ */
