/**
 * @file src/include/sysdep/linux_i386.h
 * Linux/i386 specific.
 */
#ifndef LINUX_I386_H
#define LINUX_I386_H


/***********************************************************
 * VARIOUS (needed here, others use them)
 ***********************************************************/
typedef unsigned long	ino_t;
typedef unsigned long	mode_t;
typedef long		off_t;
typedef long long	off64_t;
typedef long		pid_t;
typedef unsigned long	uid_t;


/***********************************************************
 * LIMITS
 ***********************************************************/
#define NAME_MAX			255
#define MAXSYMLINKS			 20
#define HOST_NAME_MAX			 64
#define MAXHOSTNAMELEN			 HOST_NAME_MAX


/***********************************************************
 * SYSCALLS
 ***********************************************************/
#define SYS_restart_syscall		  0
#define SYS_exit			  1
#define SYS_fork			  2
#define SYS_read			  3
#define SYS_write			  4
#define SYS_open			  5
#define SYS_close			  6
#define SYS_waitpid			  7
#define SYS_creat			  8
#define SYS_link			  9
#define SYS_unlink			 10
#define SYS_execve			 11
#define SYS_chdir			 12
#define SYS_time			 13
#define SYS_mknod			 14
#define SYS_chmod			 15
#define SYS_lchown			 16
#define SYS_break			 17
#define SYS_oldstat			 18
#define SYS_lseek			 19
#define SYS_getpid			 20
#define SYS_mount			 21
#define SYS_umount			 22
#define SYS_setuid			 23
#define SYS_getuid			 24
#define SYS_stime			 25
#define SYS_ptrace			 26
#define SYS_alarm			 27
#define SYS_oldfstat			 28
#define SYS_pause			 29
#define SYS_utime			 30
#define SYS_stty			 31
#define SYS_gtty			 32
#define SYS_access			 33
#define SYS_nice			 34
#define SYS_ftime			 35
#define SYS_sync			 36
#define SYS_kill			 37
#define SYS_rename			 38
#define SYS_mkdir			 39
#define SYS_rmdir			 40
#define SYS_dup				 41
#define SYS_pipe			 42
#define SYS_times			 43
#define SYS_prof			 44
#define SYS_brk				 45
#define SYS_setgid			 46
#define SYS_getgid			 47
#define SYS_signal			 48
#define SYS_geteuid			 49
#define SYS_getegid			 50
#define SYS_acct			 51
#define SYS_umount2			 52
#define SYS_lock			 53
#define SYS_ioctl			 54
#define SYS_fcntl			 55
#define SYS_mpx				 56
#define SYS_setpgid			 57
#define SYS_ulimit			 58
#define SYS_oldolduname			 59
#define SYS_umask			 60
#define SYS_chroot			 61
#define SYS_ustat			 62
#define SYS_dup2			 63
#define SYS_getppid			 64
#define SYS_getpgrp			 65
#define SYS_setsid			 66
#define SYS_sigaction			 67
#define SYS_sgetmask			 68
#define SYS_ssetmask			 69
#define SYS_setreuid			 70
#define SYS_setregid			 71
#define SYS_sigsuspend			 72
#define SYS_sigpending			 73
#define SYS_sethostname			 74
#define SYS_setrlimit			 75
#define SYS_getrlimit			 76
#define SYS_getrusage			 77
#define SYS_gettimeofday		 78
#define SYS_settimeofday		 79
#define SYS_getgroups			 80
#define SYS_setgroups			 81
#define SYS_select			 82
#define SYS_symlink			 83
#define SYS_oldlstat			 84
#define SYS_readlink			 85
#define SYS_uselib			 86
#define SYS_swapon			 87
#define SYS_reboot			 88
#define SYS_readdir			 89
#define SYS_mmap			 90
#define SYS_munmap			 91
#define SYS_truncate			 92
#define SYS_ftruncate			 93
#define SYS_fchmod			 94
#define SYS_fchown			 95
#define SYS_getpriority			 96
#define SYS_setpriority			 97
#define SYS_profil			 98
#define SYS_statfs			 99
#define SYS_fstatfs			100
#define SYS_ioperm			101
#define SYS_socketcall			102
#define SYS_syslog			103
#define SYS_setitimer			104
#define SYS_getitimer			105
#define SYS_stat			106
#define SYS_lstat			107
#define SYS_fstat			108
#define SYS_olduname			109
#define SYS_iopl			110
#define SYS_vhangup			111
#define SYS_idle			112
#define SYS_vm86old			113
#define SYS_wait4			114
#define SYS_swapoff			115
#define SYS_sysinfo			116
#define SYS_ipc				117
#define SYS_fsync			118
#define SYS_sigreturn			119
#define SYS_clone			120
#define SYS_setdomainname		121
#define SYS_uname			122
#define SYS_modify_ldt			123
#define SYS_adjtimex			124
#define SYS_mprotect			125
#define SYS_sigprocmask			126
#define SYS_create_module		127
#define SYS_init_module			128
#define SYS_delete_module		129
#define SYS_get_kernel_syms		130
#define SYS_quotactl			131
#define SYS_getpgid			132
#define SYS_fchdir			133
#define SYS_bdflush			134
#define SYS_sysfs			135
#define SYS_personality			136
#define SYS_afs_syscall			137
#define SYS_setfsuid			138
#define SYS_setfsgid			139
#define SYS__llseek			140
#define SYS_getdents			141
#define SYS__newselect			142
#define SYS_flock			143
#define SYS_msync			144
#define SYS_readv			145
#define SYS_writev			146
#define SYS_getsid			147
#define SYS_fdatasync			148
#define SYS__sysctl			149
#define SYS_mlock			150
#define SYS_munlock			151
#define SYS_mlockall			152
#define SYS_munlockall			153
#define SYS_sched_setparam		154
#define SYS_sched_getparam		155
#define SYS_sched_setscheduler		156
#define SYS_sched_getscheduler		157
#define SYS_sched_yield			158
#define SYS_sched_get_priority_max	159
#define SYS_sched_get_priority_min	160
#define SYS_sched_rr_get_interval	161
#define SYS_nanosleep			162
#define SYS_mremap			163
#define SYS_setresuid			164
#define SYS_getresuid			165
#define SYS_vm86			166
#define SYS_query_module		167
#define SYS_poll			168
#define SYS_nfsservctl			169
#define SYS_setresgid			170
#define SYS_getresgid			171
#define SYS_prctl			172
#define SYS_rt_sigreturn		173
#define SYS_rt_sigaction		174
#define SYS_rt_sigprocmask		175
#define SYS_rt_sigpending		176
#define SYS_rt_sigtimedwait		177
#define SYS_rt_sigqueueinfo		178
#define SYS_rt_sigsuspend		179
#define SYS_pread64			180
#define SYS_pwrite64			181
#define SYS_chown			182
#define SYS_getcwd			183
#define SYS_capget			184
#define SYS_capset			185
#define SYS_sigaltstack			186
#define SYS_sendfile			187
#define SYS_getpmsg			188
#define SYS_putpmsg			189
#define SYS_vfork			190
#define SYS_ugetrlimit			191
#define SYS_mmap2			192
#define SYS_truncate64			193
#define SYS_ftruncate64			194
#define SYS_stat64			195
#define SYS_lstat64			196
#define SYS_fstat64			197
#define SYS_lchown32			198
#define SYS_getuid32			199
#define SYS_getgid32			200
#define SYS_geteuid32			201
#define SYS_getegid32			202
#define SYS_setreuid32			203
#define SYS_setregid32			204
#define SYS_getgroups32			205
#define SYS_setgroups32			206
#define SYS_fchown32			207
#define SYS_setresuid32			208
#define SYS_getresuid32			209
#define SYS_setresgid32			210
#define SYS_getresgid32			211
#define SYS_chown32			212
#define SYS_setuid32			213
#define SYS_setgid32			214
#define SYS_setfsuid32			215
#define SYS_setfsgid32			216
#define SYS_pivot_root			217
#define SYS_mincore			218
#define SYS_madvise			219
#define SYS_madvise1			219
#define SYS_getdents64			220
#define SYS_fcntl64			221
/* 223 is unused */
#define SYS_gettid			224
#define SYS_readahead			225
#define SYS_setxattr			226
#define SYS_lsetxattr			227
#define SYS_fsetxattr			228
#define SYS_getxattr			229
#define SYS_lgetxattr			230
#define SYS_fgetxattr			231
#define SYS_listxattr			232
#define SYS_llistxattr			233
#define SYS_flistxattr			234
#define SYS_removexattr			235
#define SYS_lremovexattr		236
#define SYS_fremovexattr		237
#define SYS_tkill			238
#define SYS_sendfile64			239
#define SYS_futex			240
#define SYS_sched_setaffinity		241
#define SYS_sched_getaffinity		242
#define SYS_set_thread_area		243
#define SYS_get_thread_area		244
#define SYS_io_setup			245
#define SYS_io_destroy			246
#define SYS_io_getevents		247
#define SYS_io_submit			248
#define SYS_io_cancel			249
#define SYS_fadvise64			250
/* 251 is available for reuse (was briefly sys_set_zone_reclaim) */
#define SYS_exit_group			252
#define SYS_lookup_dcookie		253
#define SYS_epoll_create		254
#define SYS_epoll_ctl			255
#define SYS_epoll_wait			256
#define SYS_remap_file_pages		257
#define SYS_set_tid_address		258
#define SYS_timer_create		259
#define SYS_timer_settime		(SYS_timer_create+1)
#define SYS_timer_gettime		(SYS_timer_create+2)
#define SYS_timer_getoverrun		(SYS_timer_create+3)
#define SYS_timer_delete		(SYS_timer_create+4)
#define SYS_clock_settime		(SYS_timer_create+5)
#define SYS_clock_gettime		(SYS_timer_create+6)
#define SYS_clock_getres		(SYS_timer_create+7)
#define SYS_clock_nanosleep		(SYS_timer_create+8)
#define SYS_statfs64			268
#define SYS_fstatfs64			269
#define SYS_tgkill			270
#define SYS_utimes			271
#define SYS_fadvise64_64		272
#define SYS_vserver			273
#define SYS_mbind			274
#define SYS_get_mempolicy		275
#define SYS_set_mempolicy		276
#define SYS_mq_open 			277
#define SYS_mq_unlink			(SYS_mq_open+1)
#define SYS_mq_timedsend		(SYS_mq_open+2)
#define SYS_mq_timedreceive		(SYS_mq_open+3)
#define SYS_mq_notify			(SYS_mq_open+4)
#define SYS_mq_getsetattr		(SYS_mq_open+5)
#define SYS_kexec_load			283
#define SYS_waitid			284
/* #define SYS_sys_setaltroot	285 */
#define SYS_add_key			286
#define SYS_request_key			287
#define SYS_keyctl			288
#define SYS_ioprio_set			289
#define SYS_ioprio_get			290
#define SYS_inotify_init		291
#define SYS_inotify_add_watch		292
#define SYS_inotify_rm_watch		293
#define SYS_migrate_pages		294
#define SYS_openat			295
#define SYS_mkdirat			296
#define SYS_mknodat			297
#define SYS_fchownat			298
#define SYS_futimesat			299
#define SYS_fstatat64			300
#define SYS_unlinkat			301
#define SYS_renameat			302
#define SYS_linkat			303
#define SYS_symlinkat			304
#define SYS_readlinkat			305
#define SYS_fchmodat			306
#define SYS_faccessat			307
#define SYS_pselect6			308
#define SYS_ppoll			309
#define SYS_unshare			310
#define SYS_set_robust_list		311
#define SYS_get_robust_list		312
#define SYS_splice			313
#define SYS_sync_file_range		314
#define SYS_tee				315
#define SYS_vmsplice			316
#define SYS_move_pages			317
#define SYS_getcpu			318
#define SYS_epoll_pwait			319


/***********************************************************
 * ACCESS
 ***********************************************************/
#define F_OK				0
#define X_OK				1
#define W_OK				2
#define R_OK				4


/***********************************************************
 * CLONE
 ***********************************************************/
#define CLONE_VM			0x00000100
#define CLONE_FS			0x00000200
#define CLONE_FILES			0x00000400
#define CLONE_SIGHAND			0x00000800
#define CLONE_PTRACE			0x00002000
#define CLONE_PARENT			0x00008000
#define CLONE_THREAD			0x00010000
#define CLONE_NEWNS			0x00020000
#define CLONE_SYSVSEM			0x00040000
#define CLONE_SETTLS			0x00080000
#define CLONE_PARENT_SETTID		0x00100000
#define CLONE_CHILD_CLEARTID		0x00200000
#define CLONE_DETACHED			0x00400000
#define CLONE_UNTRACED			0x00800000
#define CLONE_CHILD_SETTID		0x01000000
#define CLONE_STOPPED			0x02000000
#define CLONE_NEWUTS			0x04000000
#define CLONE_NEWIPC			0x08000000


/***********************************************************
 * DIRENT
 ***********************************************************/
/* posix dirent */
/*
struct dirent {
	ino_t		d_ino;
	char		d_name[NAME_MAX + 1];
};
*/

/* linux dirent */
struct linux_dirent {
	unsigned long	d_ino;
	unsigned long	d_off;
	unsigned short	d_reclen;
	char		d_name[NAME_MAX + 1];
};

#define	dirent				linux_dirent


/***********************************************************
 * ERRNO
 ***********************************************************/
#define	EPERM				1
#define	ENOENT		 		2
#define	ESRCH		 		3
#define	EINTR		 		4
#define	EIO		 		5
#define	ENXIO		 		6
#define	E2BIG		 		7
#define	ENOEXEC		 		8
#define	EBADF		 		9
#define	ECHILD				10
#define	EAGAIN				11
#define	ENOMEM				12
#define	EACCES				13
#define	EFAULT				14
#define	ENOTBLK				15
#define	EBUSY				16
#define	EEXIST				17
#define	EXDEV				18
#define	ENODEV				19
#define	ENOTDIR				20
#define	EISDIR				21
#define	EINVAL				22
#define	ENFILE				23
#define	EMFILE				24
#define	ENOTTY				25
#define	ETXTBSY				26
#define	EFBIG				27
#define	ENOSPC				28
#define	ESPIPE				29
#define	EROFS				30
#define	EMLINK				31
#define	EPIPE				32
#define	EDOM				33
#define	ERANGE				34
#define	EDEADLK				35
#define	ENAMETOOLONG			36
#define	ENOLCK				37
#define	ENOSYS				38
#define	ENOTEMPTY			39
#define	ELOOP				40
#define	EWOULDBLOCK			EAGAIN
#define	ENOMSG				42
#define	EIDRM				43
#define	ECHRNG				44
#define	EL2NSYNC			45
#define	EL3HLT				46
#define	EL3RST				47
#define	ELNRNG				48
#define	EUNATCH				49
#define	ENOCSI				50
#define	EL2HLT				51
#define	EBADE				52
#define	EBADR				53
#define	EXFULL				54
#define	ENOANO				55
#define	EBADRQC				56
#define	EBADSLT				57
#define	EDEADLOCK			EDEADLK
#define	EBFONT				59
#define	ENOSTR				60
#define	ENODATA				61
#define	ETIME				62
#define	ENOSR				63
#define	ENONET				64
#define	ENOPKG				65
#define	EREMOTE				66
#define	ENOLINK				67
#define	EADV				68
#define	ESRMNT				69
#define	ECOMM				70
#define	EPROTO				71
#define	EMULTIHOP			72
#define	EDOTDOT				73
#define	EBADMSG				74
#define	EOVERFLOW			75
#define	ENOTUNIQ			76
#define	EBADFD				77
#define	EREMCHG				78
#define	ELIBACC				79
#define	ELIBBAD				80
#define	ELIBSCN				81
#define	ELIBMAX				82
#define	ELIBEXEC			83
#define	EILSEQ				84
#define	ERESTART			85
#define	ESTRPIPE			86
#define	EUSERS				87
#define	ENOTSOCK			88
#define	EDESTADDRREQ			89
#define	EMSGSIZE			90
#define	EPROTOTYPE			91
#define	ENOPROTOOPT			92
#define	EPROTONOSUPPORT			93
#define	ESOCKTNOSUPPORT			94
#define	EOPNOTSUPP			95
#define	EPFNOSUPPORT			96
#define	EAFNOSUPPORT			97
#define	EADDRINUSE			98
#define	EADDRNOTAVAIL			99
#define	ENETDOWN			100
#define	ENETUNREACH			101
#define	ENETRESET			102
#define	ECONNABORTED			103
#define	ECONNRESET			104
#define	ENOBUFS				105
#define	EISCONN				106
#define	ENOTCONN			107
#define	ESHUTDOWN			108
#define	ETOOMANYREFS			109
#define	ETIMEDOUT			110
#define	ECONNREFUSED			111
#define	EHOSTDOWN			112
#define	EHOSTUNREACH			113
#define	EALREADY			114
#define	EINPROGRESS			115
#define	ESTALE				116
#define	EUCLEAN				117
#define	ENOTNAM				118
#define	ENAVAIL				119
#define	EISNAM				120
#define	EREMOTEIO			121
#define	EDQUOT				122
#define	ENOMEDIUM			123
#define	EMEDIUMTYPE			124
#define	ECANCELED			125
#define	ENOKEY				126
#define	EKEYEXPIRED			127
#define	EKEYREVOKED			128
#define	EKEYREJECTED			129
#define	EOWNERDEAD			130
#define	ENOTRECOVERABLE			131
#define	ENOTSUP				EOPNOTSUPP


/***********************************************************
 * FCNTL
 ***********************************************************/
#define F_DUPFD				0
#define F_GETFD				1
#define F_SETFD				2
#define F_GETFL				3
#define F_SETFL				4
#define F_GETLK				5
#define F_SETLK				6
#define F_SETLKW			7
#define F_SETOWN			8
#define F_GETOWN			9
#define F_SETSIG			10
#define F_GETSIG			11

#define FD_CLOEXEC			1

#define F_RDLCK				0
#define F_WRLCK				1
#define F_UNLCK				2

struct flock {
	short	l_type;
	short	l_whence;
	off_t	l_start;
	off_t	l_len;
	pid_t	l_pid;
};


/***********************************************************
 * FUTEX
 ***********************************************************/
#define FUTEX_WAIT			0
#define FUTEX_WAKE			1
#define FUTEX_FD			2
#define FUTEX_REQUEUE			3
#define FUTEX_CMP_REQUEUE		4
#define FUTEX_WAKE_OP			5
#define FUTEX_LOCK_PI			6
#define FUTEX_UNLOCK_PI			7
#define FUTEX_TRYLOCK_PI		8
#define FUTEX_PRIVATE_FLAG		128


/***********************************************************
 * LSEEK
 ***********************************************************/
#define SEEK_SET			0
#define SEEK_CUR			1
#define SEEK_END			2


/***********************************************************
 * IOCTL - ioctl.h, sockio.h
 ***********************************************************/
#define FIONREAD			0x541B

#define SIOCGIFCONF			0x8912
#define SIOCGIFFLAGS			0x8913
#define SIOCGIFBRDADDR			0x8919
#define SIOCGIFNETMASK			0x891B
#define SIOCGIFMTU			0x8921
#define SIOCGIFHWADDR			0x8927
#define SIOCGIFINDEX			0x8933


/***********************************************************
 * MMAP
 ***********************************************************/
#define PROT_NONE			0x0
#define PROT_READ			0x1
#define PROT_WRITE			0x2
#define PROT_EXEC			0x4

#define MAP_FILE			0x00
#define MAP_SHARED			0x01
#define MAP_PRIVATE			0x02
#define MAP_TYPE			0x0f
#define MAP_FIXED			0x10
#define MAP_ANONYMOUS			0x20
#define MAP_ANON			MAP_ANONYMOUS

#define MAP_FAILED			((void *)-1)

#define MS_SYNC				4

#define MADV_WILLNEED			3


/***********************************************************
 * OPEN
 ***********************************************************/
#define O_ACCMODE			00000003
#define O_APPEND			00002000
#define O_CREAT				00000100
#define O_DIRECT			00040000
#define O_DIRECTORY			00200000
#define O_EXCL				00000200
#define O_LARGEFILE			00100000
#define O_NOFOLLOW			00400000
#define O_NOATIME			01000000
#define O_NDELAY			O_NONBLOCK
#define O_NOCTTY			00000400
#define O_NONBLOCK			00004000
#define O_RDONLY			00000000
#define O_WRONLY			00000001
#define O_RDWR				00000002
#define O_SYNC				00010000
#define O_DSYNC				00010000
#define O_TRUNC				00001000


/***********************************************************
 * POLL
 ***********************************************************/
#define POLLIN				0x001
#define POLLPRI				0x002
#define POLLOUT				0x004
#define POLLERR				0x008
#define POLLHUP				0x010
#define POLLNVAL			0x020

typedef unsigned long int nfds_t;

struct pollfd {
	int fd;
	short int events;
	short int revents;
};


/***********************************************************
 * SELECT
 ***********************************************************/
#define FD_SETSIZE			1024	/* Max num of fds */


typedef struct _fd_set {
	unsigned char fds_bits[FD_SETSIZE >> 3];
} fd_set;


#define FD_SET(fd, set)		do {				\
	(set)->fds_bits[(fd) >> 3] |= (1 << ((fd) % 8));	\
} while (0)


#define FD_CLR(fd, set)		do {				\
	(set)->fds_bits[(fd) >> 3] &= ~(1 << ((fd) % 8));	\
} while (0)


#define FD_ISSET(fd, set)	((set)->fds_bits[(fd) >> 3] &	\
				(1 << ((fd) % 8)))


#define FD_ZERO(set)		do {				\
	plbzero((set), sizeof(*(set)));				\
} while (0)


/***********************************************************
 * SIGNAL
 ***********************************************************/
#define SIGHUP				1
#define SIGINT		 		2
#define SIGQUIT		 		3
#define SIGILL		 		4
#define SIGTRAP		 		5
#define SIGABRT		 		6
#define SIGIOT		 		6
#define SIGBUS		 		7
#define SIGFPE		 		8
#define SIGKILL		 		9
#define SIGUSR1				10
#define SIGSEGV				11
#define SIGUSR2				12
#define SIGPIPE				13
#define SIGALRM				14
#define SIGTERM				15
#define SIGSTKFLT			16
#define SIGCHLD				17
#define SIGCONT				18
#define SIGSTOP				19
#define SIGTSTP				20
#define SIGTTIN				21
#define SIGTTOU				22
#define SIGURG				23
#define SIGXCPU				24
#define SIGXFSZ				25
#define SIGVTALRM			26
#define SIGPROF				27
#define SIGWINCH			28
#define SIGIO				29
#define SIGPOLL				SIGIO
/* #define SIGLOST				29 */
#define SIGPWR				30
#define SIGSYS				31
#define	SIGUNUSED			31

/* The following two values are from kernel 2.6.20-16 */
#define SIGRTMIN			34
#define SIGCANCEL			34
#define SIGSETXID			35

#define NSIG				64
#define _NSIG				NSIG

#define SIGRTMAX			64
#define __SIGRTMAX			64

#define _PL_BITS			(sizeof(long) << 3)

#define PL_SIGSET_VAL(signo)		(1 << (((signo)-1) % _PL_BITS))
#define PL_SIGSET_IDX(signo)		(((signo)-1) >> 5)
//XXX #define PL_SIGSET_IDX(signo)		(((signo)-1) / _PL_BITS)

/*
 * sigset_t
 */
typedef struct {
	uint32	set[_PL_BITS];
} sigset_t;

/*
 * sigval_t
 */
typedef union sigval {
	int	 sival_int;
	void	*sival_ptr;
} sigval_t;

/*
 * siginfo_t
 */
typedef struct siginfo {
	int		 si_signo;
	int		 si_errno;
	int		 si_code;
	pid_t		 si_pid;
	uid_t		 si_uid;
	void		*si_addr;
	int		 si_status;
	long int	 si_band;
	union sigval	 si_value;
} siginfo_t;

/*
 * jmp_buf
 */
#define PLJMPBUF_STORAGE		8
typedef struct _jmp_buf {
        long jmp_buf[PLJMPBUF_STORAGE];
} jmp_buf;

/*
 * sigjmp_buf
 */
typedef struct _sigjmp_buf {
	jmp_buf		sj_buf;
	int		sj_maskvalid;
	sigset_t	sj_mask;
} sigjmp_buf;

/*
 * How to treat signal sets.
 */
#define SIG_BLOCK			0
#define SIG_UNBLOCK			1
#define SIG_SETMASK			2

/*
 * Default signal handlers.
 */
#define SIG_ERR				((void *)-1)
#define SIG_DFL				((void *) 0)
#define SIG_IGN				((void *) 1)

/* 
 * Sigaltstack
 */
#define SS_ONSTACK			1
#define SS_DISABLE			2

#define MINSIGSTKSZ			2048
#define SIGSTKSZ			8192

typedef struct sigaltstack {
	void	*ss_sp;
	int	 ss_flags;
	size_t	 ss_size;
} stack_t;

/*
 * Sigaction
 */
struct sigaction {
	union {
		void	(*_sa_handler)(int);
		void	(*_sa_sigaction)(int, struct siginfo *, void *);
	} _u;
	sigset_t	sa_mask;
	unsigned long	sa_flags;
	void		(*sa_restorer)(void);
};

struct kernel_sigaction {
	void		(*k_sa_handler)(int);
	unsigned long	sa_flags;
	void		(*sa_restorer)(void);
	sigset_t	sa_mask;
};

#define sa_handler	_u._sa_handler
#define sa_sigaction	_u._sa_sigaction


/*
 * sa_flags values:
 *
 * SA_ONSTACK indicates that a registered stack_t will be used.
 * SA_RESTART flag to get restarting signals (which were the default long ago)
 * SA_NOCLDSTOP flag to turn off SIGCHLD when children stop.
 * SA_RESETHAND clears the handler when the signal is delivered.
 * SA_NOCLDWAIT flag on SIGCHLD to inhibit zombies.
 * SA_NODEFER prevents the current signal from being masked in the handler.
 *
 * SA_ONESHOT and SA_NOMASK are the historical Linux names for the Single
 * Unix names RESETHAND and NODEFER respectively.
 */
#define SA_NOCLDSTOP			1
#define SA_NOCLDWAIT			2
#define SA_SIGINFO			4
#define SA_ONSTACK			0x08000000
#define SA_RESTART			0x10000000
#define SA_NODEFER			0x40000000
#define SA_RESETHAND			0x80000000

#define SA_NOMASK			SA_NODEFER
#define SA_ONESHOT			SA_RESETHAND

#define SA_RESTORER			0x04000000


/***********************************************************
 * SOCKET
 ***********************************************************/
/*
 * Command argument for the SYS_socketcall syscall.
 */
#define SOCKETCALL_SOCKET		1
#define SOCKETCALL_BIND			2
#define SOCKETCALL_CONNECT		3
#define SOCKETCALL_LISTEN		4
#define SOCKETCALL_ACCEPT		5
#define SOCKETCALL_GETSOCKNAME		6
#define SOCKETCALL_GETPEERNAME		7
#define SOCKETCALL_SOCKETPAIR		8
#define SOCKETCALL_SEND			9
#define SOCKETCALL_RECV			10
#define SOCKETCALL_SENDTO		11
#define SOCKETCALL_RECVFROM		12
#define SOCKETCALL_SHUTDOWN		13
#define SOCKETCALL_SETSOCKOPT		14
#define SOCKETCALL_GETSOCKOPT		15
#define SOCKETCALL_SENDMSG		16
#define SOCKETCALL_RECVMSG		17

/*
 * Socket Address Family.
 */
#define AF_UNSPEC			0
#define AF_UNIX				1
#define AF_LOCAL			1
#define AF_INET				2
#define AF_AX25				3
#define AF_IPX				4
#define AF_APPLETALK			5
#define AF_NETROM			6
#define AF_BRIDGE			7
#define AF_ATMPVC			8
#define AF_X25				9
#define AF_INET6			10
#define AF_ROSE				11
#define AF_DECnet			12
#define AF_NETBEUI			13
#define AF_SECURITY			14
#define AF_KEY				15
#define AF_NETLINK			16
#define AF_ROUTE			AF_NETLINK
#define AF_PACKET			17
#define AF_ASH				18
#define AF_ECONET			19
#define AF_ATMSVC			20
#define AF_SNA				22
#define AF_IRDA				23
#define AF_PPPOX			24
#define AF_WANPIPE			25
#define AF_LLC				26
#define AF_TIPC				30
#define AF_BLUETOOTH			31
#define AF_MAX				32

/*
 * Protocol Family.
 */
#define PF_UNSPEC			0
#define PF_LOCAL			1
#define PF_UNIX				PF_LOCAL

/*
 * Socket Types.
 */
#define	SOCK_STREAM			1
#define	SOCK_DGRAM			2
#define	SOCK_RAW			3
#define	SOCK_RDM			4
#define SOCK_SEQPACKET			5
#define SOCK_PACKET			10

typedef int	socklen_t;
typedef uint16	sa_family_t;

struct sockaddr {
	sa_family_t	sa_family;
	char		sa_data[14];
};

struct linger {
	int		l_onoff;
	int		l_linger;
};

/*
 * IPv4
 */
typedef uint32	in_addr_t;
typedef uint16	in_port_t;

struct in_addr {
	in_addr_t	s_addr;
};

struct sockaddr_in {
	sa_family_t	sin_family;

	in_port_t	sin_port;
	struct in_addr	sin_addr;

	char		sin_zero[8];
};

/* Correct? */
struct ip_mreq {
	struct in_addr	imr_multiaddr;
	struct in_addr	imr_interface;
};

/* Linux? */
struct ip_mreqn {
	struct in_addr	imr_multiaddr;
	struct in_addr	imr_address;
	int		imr_ifindex;
};


/*
 * IPv6
 */
struct in6_addr {
	union {
		uint8	u6_addr8[16];
		uint16	u6_addr16[8];
		uint32	u6_addr32[4];
	} u6_addr;
};

#define s6_addr		u6_addr.u6_addr8
#define s6_addr16	u6_addr.u6_addr16
#define s6_addr32	u6_addr.u6_addr32

struct sockaddr_in6 {
	uint16		sin6_family;
	uint16		sin6_port;
	uint32		sin6_flowinfo;
	struct in6_addr	sin6_addr;
	uint32		sin6_scope_id;
};

struct ipv6_mreq {
	struct in6_addr	ipv6mr_multiaddr;
	unsigned int	ipv6mr_interface;
};

#define IPV6_FLOWINFO_SEND		33
  
/*
 * Argument 'how' for plsock_shutdown().
 */
#define SHUT_RD				0
#define SHUT_WR				1
#define SHUT_RDWR 			2

/*
 * Socket Levels plsys_getsockopt() and plsys_setsockopt().
 */
#define SOL_IP				0
#define SOL_SOCKET			1
#define SOL_TCP				6
#define SOL_UDP				17
#define SOL_IPV6			41
#define SOL_ICMPV6			58
#define SOL_SCTP			132
#define SOL_UDPLITE			136
#define SOL_RAW				255
#define SOL_IPX				256
#define SOL_AX25			257
#define SOL_ATALK			258
#define SOL_NETROM			259
#define SOL_ROSE			260
#define SOL_DECNET			261
#define SOL_X25				262
#define SOL_PACKET			263
#define SOL_ATM				264
#define SOL_AAL				265
#define SOL_IRDA			266
#define SOL_NETBEUI			267
#define SOL_LLC				268
#define SOL_DCCP			269
#define SOL_NETLINK			270
#define SOL_TIPC			271

/*
 * Socket Options for SOL_SOCKET level.
 */
#define SO_DEBUG			1
#define SO_REUSEADDR			2
#define SO_TYPE				3
#define SO_ERROR			4
#define SO_DONTROUTE			5
#define SO_BROADCAST			6
#define SO_SNDBUF			7
#define SO_RCVBUF			8
#define SO_KEEPALIVE			9
#define SO_OOBINLINE			10
#define SO_NO_CHECK			11
#define SO_PRIORITY			12
#define SO_LINGER			13
#define SO_BSDCOMPAT			14
#define SO_PASSCRED			16
#define SO_PEERCRED			17
#define SO_RCVLOWAT			18
#define SO_SNDLOWAT			19
#define SO_RCVTIMEO			20
#define SO_SNDTIMEO			21
#define SO_SECURITY_AUTHENTICATION	22
#define SO_SECURITY_ENCRYPTION_TRANSPORT 23
#define SO_SECURITY_ENCRYPTION_NETWORK	24
#define SO_BINDTODEVICE			25
#define SO_ATTACH_FILTER		26
#define SO_DETACH_FILTER		27
#define SO_PEERNAME			28
#define SO_TIMESTAMP			29
#define SCM_TIMESTAMP			SO_TIMESTAMP
#define SO_ACCEPTCONN			30
#define SO_PEERSEC			31
#define SO_SNDBUFFORCE			32
#define SO_RCVBUFFORCE			33
#define SO_PASSSEC			34

/*
 * Socket options for IPPROTO_IP level.
 */
#define IP_TOS				1
#define IP_TTL				2
#define IP_MULTICAST_IF			32
#define IP_MULTICAST_TTL		33
#define IP_MULTICAST_LOOP		34
#define IP_ADD_MEMBERSHIP		35
#define IP_DROP_MEMBERSHIP		36

/*
 * Socket options for IPPROTO_TCP level.
 */
#define TCP_NODELAY			1
#define TCP_MAXSEG			2
#define TCP_CORK			3
#define TCP_KEEPIDLE			4
#define TCP_KEEPINTVL			5
#define TCP_KEEPCNT			6
#define TCP_SYNCNT			7
#define TCP_LINGER2			8
#define TCP_DEFER_ACCEPT		9
#define TCP_WINDOW_CLAMP		10
#define TCP_INFO			11
#define TCP_QUICKACK			12

/*
 * Socket options for IPPROTO_IPV6 level.
 */
#define IPV6_ADDRFORM			1
#define IPV6_2292PKTINFO		2
#define IPV6_2292HOPOPTS		3
#define IPV6_2292DSTOPTS		4
#define IPV6_2292RTHDR			5
#define IPV6_2292PKTOPTIONS		6
#define IPV6_CHECKSUM			7
#define IPV6_2292HOPLIMIT		8

#define SCM_SRCRT			IPV6_RXSRCRT

#define IPV6_NEXTHOP			9
#define IPV6_AUTHHDR			10
#define IPV6_UNICAST_HOPS		16
#define IPV6_MULTICAST_IF		17
#define IPV6_MULTICAST_HOPS		18
#define IPV6_MULTICAST_LOOP		19
#define IPV6_JOIN_GROUP			20
#define IPV6_LEAVE_GROUP		21
#define IPV6_ROUTER_ALERT		22
#define IPV6_MTU_DISCOVER		23
#define IPV6_MTU			24
#define IPV6_RECVERR			25
#define IPV6_V6ONLY			26
#define IPV6_JOIN_ANYCAST		27
#define IPV6_LEAVE_ANYCAST		28
#define IPV6_IPSEC_POLICY		34
#define IPV6_XFRM_POLICY		35

#define IPV6_RECVPKTINFO		49
#define IPV6_PKTINFO			50
#define IPV6_RECVHOPLIMIT		51
#define IPV6_HOPLIMIT			52
#define IPV6_RECVHOPOPTS		53
#define IPV6_HOPOPTS			54
#define IPV6_RTHDRDSTOPTS		55
#define IPV6_RECVRTHDR			56
#define IPV6_RTHDR			57
#define IPV6_RECVDSTOPTS		58
#define IPV6_DSTOPTS			59

#define IPV6_RECVTCLASS			66
#define IPV6_TCLASS			67

#define IPV6_ADD_MEMBERSHIP		IPV6_JOIN_GROUP
#define IPV6_DROP_MEMBERSHIP		IPV6_LEAVE_GROUP
#define IPV6_RXHOPOPTS			IPV6_HOPOPTS
#define IPV6_RXDSTOPTS			IPV6_DSTOPTS

/*
 * Flags for plsys_send() and plsys_recv().
 */
#define MSG_OOB				1
#define MSG_PEEK			2
#define MSG_DONTROUTE			4
#define MSG_TRYHARD			4
#define MSG_CTRUNC			8
#define MSG_PROBE			0x10
#define MSG_TRUNC			0x20
#define MSG_DONTWAIT			0x40
#define MSG_EOR				0x80
#define MSG_WAITALL			0x100
#define MSG_FIN				0x200
#define MSG_SYN				0x400
#define MSG_CONFIRM			0x800
#define MSG_RST				0x1000
#define MSG_ERRQUEUE			0x2000
#define MSG_NOSIGNAL			0x4000
#define MSG_MORE			0x8000

#define MSG_EOF				MSG_FIN

/*
 * struct msghdr
 */
struct msghdr {
	void		*msg_name;
	socklen_t	 msg_namelen;
	struct iovec	*msg_iov;
	size_t		 msg_iovlen;
	void		*msg_control;
	size_t		 msg_controllen;
	int		 msg_flags;
};


/***********************************************************
 * INTERFACES - net/if.h
 ***********************************************************/
#define IFNAMSIZ			16
#define IFHWADDRLEN			6

#define IFF_UP				0x0001
#define IFF_BROADCAST			0x0002
#define IFF_DEBUG			0x0004
#define IFF_LOOPBACK			0x0008
#define IFF_POINTOPOINT			0x0010
#define IFF_NOTRAILERS			0x0020
#define IFF_RUNNING			0x0040
#define IFF_NOARP			0x0080
#define IFF_PROMISC			0x0100
#define IFF_MULTICAST			0x1000

struct ifmap {
	unsigned long int	mem_start;
	unsigned long int	mem_end;
	unsigned short int	base_addr;
	unsigned char		irq;
	unsigned char		dma;
	unsigned char		port;
};

struct ifreq {
	union {
		char ifrn_name[IFNAMSIZ];
	} ifr_ifrn;

	union {
		struct sockaddr	ifru_addr;
		struct sockaddr	ifru_dstaddr;
		struct sockaddr	ifru_broadaddr;
		struct sockaddr	ifru_netmask;
		struct sockaddr	ifru_hwaddr;
		short int	ifru_flags;
		int		ifru_ivalue;
		int		ifru_mtu;
		struct ifmap	ifru_map;
		char		ifru_slave[IFNAMSIZ];
		char		ifru_newname[IFNAMSIZ];
		caddr_t		ifru_data;
	} ifr_ifru;
#define ifr_name	ifr_ifrn.ifrn_name
#define ifr_hwaddr	ifr_ifru.ifru_hwaddr
#define ifr_addr	ifr_ifru.ifru_addr
#define ifr_dstaddr	ifr_ifru.ifru_dstaddr
#define ifr_broadaddr	ifr_ifru.ifru_broadaddr
#define ifr_netmask	ifr_ifru.ifru_netmask
#define ifr_flags	ifr_ifru.ifru_flags
#define ifr_metric	ifr_ifru.ifru_ivalue
#define ifr_mtu		ifr_ifru.ifru_mtu
#define ifr_map		ifr_ifru.ifru_map
#define ifr_slave	ifr_ifru.ifru_slave
#define ifr_data	ifr_ifru.ifru_data
#define ifr_ifindex	ifr_ifru.ifru_ivalue
#define ifr_index	ifr_ifindex
#define ifr_bandwidth	ifr_ifru.ifru_ivalue
#define ifr_qlen	ifr_ifru.ifru_ivalue
#define ifr_newname	ifr_ifru.ifru_newname
};


struct ifconf {
	int	ifc_len;
	union {
		caddr_t	ifcu_buf;
		struct	ifreq *ifcu_req;
	} ifc_ifcu;
#define ifc_buf		ifc_ifcu.ifcu_buf
#define ifc_req		ifc_ifcu.ifcu_req
};


/***********************************************************
 * netdb.h
 ***********************************************************/
struct addrinfo {
	int ai_flags;
	int ai_family;
	int ai_socktype;
	int ai_protocol;
	socklen_t ai_addrlen;
	struct sockaddr *ai_addr;
	char *ai_canonname;
	struct addrinfo *ai_next;
};

struct hostent {
	char	 *h_name;
	char	**h_aliases;
	int	  h_addrtype;
	int	  h_length;
	char	**h_addr_list;
#define h_addr h_addr_list[0]
};

struct protoent {
	char	 *p_name;
	char	**p_aliases;
	int	  p_proto;
};

#define	NETDB_INTERNAL		-1
#define	NETDB_SUCCESS		0
#define	HOST_NOT_FOUND		1
#define	TRY_AGAIN		2
#define	NO_RECOVERY		3
#define	NO_DATA			4
#define	NO_ADDRESS		NO_DATA

#define AI_PASSIVE		1
#define AI_CANONNAME		2
#define AI_NUMERICHOST		4
#define AI_EXT			8
#define AI_NUMERICSERV		16

#define NI_NUMERICHOST		1
#define NI_NUMERICSERV		2
#define NI_NOFQDN		4
#define NI_NAMEREQD		8
#define NI_DGRAM		16
#define NI_MAXHOST		1025
#define NI_MAXSERV		32


/***********************************************************
 * STAT
 ***********************************************************/
#define S_IFMT				0170000
#define S_IFSOCK			0140000
#define S_IFLNK				0120000
#define S_IFREG				0100000
#define S_IFBLK				0060000
#define S_IFDIR				0040000
#define S_IFCHR				0020000
#define S_IFIFO				0010000
#define S_ISUID				0004000
#define S_ISGID				0002000
#define S_ISVTX				0001000
#define S_IRWXU				00700
#define S_IRUSR				00400
#define S_IWUSR				00200
#define S_IXUSR				00100
#define S_IRWXG				00070
#define S_IRGRP				00040
#define S_IWGRP				00020
#define S_IXGRP				00010
#define S_IRWXO				00007
#define S_IROTH				00004
#define S_IWOTH				00002
#define S_IXOTH				00001

typedef struct stat {
	unsigned long	st_dev;
	unsigned long	st_ino;
	unsigned short	st_mode;
	unsigned short	st_nlink;
	unsigned short	st_uid;
	unsigned short	st_gid;
	unsigned long	st_rdev;
	unsigned long	st_size;
	unsigned long	st_blksize;
	unsigned long	st_blocks;
	unsigned long	st_atime;
	unsigned long	st_atime_nsec;
	unsigned long	st_mtime;
	unsigned long	st_mtime_nsec;
	unsigned long	st_ctime;
	unsigned long	st_ctime_nsec;
	unsigned long	__unused4;
	unsigned long	__unused5;
} stat_t;

#define S_ISDIR(m)	(((m) & S_IFDIR) == S_IFDIR)
#define S_ISREG(m)	(((m) & S_IFMT) == S_IFREG)
#define S_ISLNK(m)	(((m) & S_IFMT) == S_IFLNK)
#define S_ISCHR(m)	(((m) & S_IFMT) == S_IFCHR)
#define S_ISFIFO(m)	(((m) & S_IFMT) == S_IFIFO)
#define S_ISSOCK(m)	(((m) & S_IFMT) == S_IFSOCK)


/***********************************************************
 * TIME
 ***********************************************************/
typedef long	time_t;

struct timespec {
	time_t	tv_sec;
	long	tv_nsec;
};

struct timeval {
	time_t	tv_sec;
	long	tv_usec;
};

struct timezone {
	int	tz_minuteswest;
	int	tz_dsttime;
};

struct tm {
	int	 tm_sec;
	int	 tm_min;
	int	 tm_hour;
	int	 tm_mday;
	int	 tm_mon;
	int	 tm_year;
	int	 tm_wday;
	int	 tm_yday;
	int	 tm_isdst;

	long int tm_gmtoff;
	char	*tm_zone;
};


/***********************************************************
 * UNAME
 ***********************************************************/
struct utsname {
	char sysname[65];
	char nodename[65];
	char release[65];
	char version[65];
	char machine[65];

	/* Do not use: is not standard and depends on compilation flags */
	char domainname[65];
};


/***********************************************************
 * WAIT
 ***********************************************************/
#define WNOHANG				0x00000001
#define WUNTRACED			0x00000002
#define WSTOPPED			WUNTRACED
#define WEXITED				0x00000004
#define WCONTINUED			0x00000008

/*
 * First argument to waitpid.
 */
#define P_ALL				0
#define P_PID				1
#define P_PGID				2

#define WTERMSIG(status)		((status) & 0x7f)

#define WIFEXITED(status)		(WTERMSIG((status)) == 0)

#define WEXITSTATUS(status)		(((status) & 0xff00) >> 8)

#define WIFSIGNALED(status)		(((signed char) \
					(((status) & 0x7f) + 1) >> 1) > 0)


#endif	/* LINUX_I386_H */
