/**
 * @file src/lib/plc/hash_fnv.c
 */
#include <plc.h>


/**
 * Hash method from Fowler/Noll/Vo.
 */
unsigned int PLEXPORT
FNVHash(const char *str, unsigned int len)
{
	const unsigned int fnv_prime = 0x811C9DC5;
	unsigned int hash = 0, i = 0;

	for (i = 0; i < len; str++, i++) {
		hash *= fnv_prime;
		hash ^= (*str);
	}

	return hash;
}

