/**
 * @file src/lib/plc/init.c
 * Peludo LibC - Module initialization and finalization.
 */
#include <plc.h>


/**
 * Initialize the Peludo PLC Module.
 * Called by Peludo Kernel when loading plc.pld.
 *
 * @see PLSTATUS
 * @see plinit()
 */
PLSTATUS PLEXPORT
_init()
{
	return plinit();
}


/**
 * Release the Peludo PLC Module.
 * Called by Peludo Kernel when unloading plc.pld.
 *
 * @see _init()
 * @see plrelease()
 */
void PLEXPORT
_fini()
{
	plrelease();
}


