/**
 * @file src/lib/plc/pldhash.c
 */
#include <pldhash.h>
#include "hash.h"


/**
 * By default DJBHash is used into PLD files.
 *
 * @see DJBHash()
 *
 * @warning This file cannot be used by the peludo kernel becausee
 * this variable is initialized with a value other than NULL hhmmm 
 * but points to the code section.
 */
static unsigned int (*_pldhash)(const char *, unsigned int) = &DJBHash;


/**
 * Peludo hash method.
 *
 * @see _pldhash()
 */
uint32 PLEXPORT
pldhash(const char *buf, size_t len)
{
	return ((uint32)(*_pldhash)(buf, len));
}

