/**
 * @file src/lib/plc/plexit.c
 */
#include <plc.h>


/**
 * Pointer to the termination callback.
 */
static void (*_exit)(long) = NULL;
				/*
				 * Can't have a default value other than NULL:
				 * Read docs about kernel coding constraints.
				 */


void PLEXPORT
plsetexit(void (*fn)(long), void (**old)(long))
{
	if (old != NULL) {
		*old = _exit;
	}

	_exit = fn;
}


void PLEXPORT
plexit(long retval)
{
	if (_exit != NULL) {
		/*
		 * Call user's termination callback.
		 */
		_exit(retval);
	}

	/*
	 * Terminate the process.
	 */
	plsys_exit(retval);
	/* NOTREACHED */
}


