/**
 * @file src/lib/plc/plsigblock.c
 */
#include <plc.h>
#include <pllog.h>


void PLEXPORT
plsigblock(sigset_t *oset)
{
	PLSTATUS st;
	sigset_t set;

	plsys_sigfillset(&set);
	st = plsys_tsigmask_nt(SIG_BLOCK, &set, oset);
	if (st != PLSTATUS_SUCCESS) {
		pldebug("%s: Can't block signals, peludo code=%s, errno=%d\n",
		    __FUNCTION__,
		    plstrstatus(st),
		    errno);

		plsys_exit(-1);   /* XXX Let the user to manage the error? */
		/* NOTREACHED */
	}
}


void PLEXPORT
plsigunblock(const sigset_t *set)
{
	PLSTATUS st;

	st = plsys_tsigmask_nt(SIG_SETMASK, set, NULL);
	if (st != PLSTATUS_SUCCESS) {
		pldebug("%s: Can't restore signals, peludo code=%s, errno=%d\n",
		    __FUNCTION__,
		    plstrstatus(st),
		    errno);

		plsys_exit(-1);   /* XXX Let the user to manage the error? */
		/* NOTREACHED */
	}
}


