/**
 * @file src/lib/plc/plstrstatus.c
 */
#include <plc.h>


const char PLEXPORT *
plstrstatus(PLSTATUS status)
{
#ifdef PLDEBUG
	switch (status) {
	case PLSTATUS_SUCCESS:
		return "Success";

	case PLSTATUS_FAILED:
		return "Failed";

	case PLSTATUS_INVALID:
		return "Invalid";

	case PLSTATUS_INVALID_ADDRESS:
		return "Invalid Peludo Address";

	case PLSTATUS_MALFORMED_TABLE:
		return "Malformed Table";

	case PLSTATUS_MODULE_NAME_DUPLICATED:
		return "Another module is using the same name";

	case PLSTATUS_MODULE_NOT_FOUND:
		return "Module not found";

        case PLSTATUS_NOT_IMPLEMENTED:
		return "Feature Not Implemented";

	case PLSTATUS_OUT_OF_MEMORY:
		return "Out of memory";

	case PLSTATUS_SECTION_NOT_FOUND:
		return "Section not found";

	case PLSTATUS_SYMBOL_NOT_FOUND:
		return "Symbol not found";

	case PLSTATUS_TIMEOUT:
		return "Timeout";

	case PLSTATUS_TRY_AGAIN:
		return "Try again";

	default:;
	}

	return "Unknown Peludo Code";

#else

	return "";

#endif	/* PLDEBUG */
}


