/**
 * @file src/lib/plc/plvsnprint.c
 */
#include <plc.h>


extern int plvnprint_cb(const char *, plva_list,
    int (*)(void *, const char *, size_t), void *, size_t);


static int _print(void *dst, const char *src, size_t siz)
{
	size_t srclen;

	srclen = plstrlen(src);

	if (srclen + plstrlen(dst) < siz) {
		plstrcat((char *)dst, src);
		return srclen;
	}

	return 0;
}


int PLEXPORT
plvsnprint(char *dst, size_t siz, const char *fmt, plva_list args)
{
	*dst = '\0';
	return plvnprint_cb(fmt, args, (void *)_print, dst, siz);
}


