/**
 * @file src/lib/plc/std/fcntl_fcntl.c
 */
#include <fcntl.h>


int PLEXPORT
fcntl(int fd, int cmd, ...)
{
	long value, result;
	plva_list va;
	PLSTATUS st;

	plenter_cancel_point();

	plva_start(va, cmd);
	value = plva_arg(va, long);
	plva_end(va);

	st = plsys_fcntl(&result, fd, cmd, value);

	plleave_cancel_point();

	return ((st == PLSTATUS_SUCCESS) ? (int)result : -1);
}


