/**
 * @file src/lib/plc/std/plstd_init.c
 */
#include <plc.h>
#include <stdio.h>
#include <unistd.h>


#ifdef PLOS_win32
/* XXX */
#error "plstd_init.c NOT PORTED TO WIN32."
#endif


/*
 * Initialized to 0 due to kernel coding restritions
 * (can't assume PLC is not integrated into the peludo kernel);
 * see src/core/kernel/README.
 */
static FILE _stdin  = { 0 };
static FILE _stdout = { 0 };
static FILE _stderr = { 0 };

FILE PLEXPORT *stdin  = NULL;
FILE PLEXPORT *stdout = NULL;
FILE PLEXPORT *stderr = NULL;


/**
 * Initialize the standard C part of PLC.
 *
 * @return A Peludo Status code is returned.
 *
 * @see PLSTATUS
 */
PLSTATUS PLEXPORT
plstd_init()
{
	_stdin.f_fd  = STDIN_FILENO;
	_stdout.f_fd = STDOUT_FILENO;
	_stderr.f_fd = STDERR_FILENO;

	stdin  = &_stdin;
	stdout = &_stdout;
	stderr = &_stderr;

	return PLSTATUS_SUCCESS;
}

