/**
 * @file src/lib/plc/std/stdio_fread.c
 */
#include <plc.h>
#include <stdio.h>


size_t PLEXPORT
fread(void *ptr, size_t size, size_t nmemb, FILE *stream)
{
	size_t rd;

	if (ptr == NULL || stream == NULL) {
		errno = EINVAL;
		return 0;
	}

	/* Return 0 on error because fread() can't detect errors */
	return ((plsys_read((long)stream->f_fd, ptr, size * nmemb, &rd) ==
	    PLSTATUS_SUCCESS) ? rd : 0);
}


