/**
 * @file src/lib/plc/std/stdio_fwrite.c
 */
#include <plc.h>
#include <stdio.h>


size_t PLEXPORT
fwrite(const void *ptr, size_t size, size_t nmemb, FILE *stream)
{
	size_t wt;

	if (ptr == NULL || stream == NULL) {
		errno = EINVAL;
		return 0;
	}
	
	/* Return 0 on error because fwrite() can't detect errors */
	return ((plsys_write((long)stream->f_fd, ptr, size * nmemb, &wt) ==
	    PLSTATUS_SUCCESS) ? wt : 0);
}


