/**
 * @file src/lib/plc/std/stdio_vfprintf.c
 */
#include <plc.h>
#include <limits.h>
#include <stdio.h>


extern int plvnprint_cb(const char *fmt, va_list args,
    int (*doprint)(void *, const char *, size_t), void *par, size_t siz);


static int
_print(void *dst, const char *src, size_t siz)
{
	size_t ret, psiz;
	FILE *f = (FILE *)dst;

	psiz = plstrlen(src);
	if (psiz > siz) {
		psiz = siz;
	}

	plsys_write((long)(f->f_fd), src, psiz, &ret);

	return ret;
}


int PLEXPORT
vfprintf(FILE *f, const char *fmt, va_list ap)
{
	if (f == NULL) {
		errno = EINVAL;
		return -1;
	}

	return plvnprint_cb(fmt, ap, (void *)_print, f, INT_MAX);
}


