/**
 * @file src/lib/plc/std/stdlib_malloc.c
 */
#include <plc.h>

#include <stdlib.h>
#include <string.h>


void PLEXPORT *
malloc(size_t size)
{
	return plmalloc(size);
}


void PLEXPORT *
calloc(size_t nelem, size_t elsize)
{
	size_t size;
	void *addr;

	size = nelem * elsize;
	if (size == 0) {
		return NULL;
	}

	addr = malloc(size);
	if (addr != NULL) {
		bzero(addr, size);
	}

	return addr;
}


void PLEXPORT
free(void *ptr)
{
	plfree(ptr);
}


