/**
 * @file src/lib/plc/std/sys_mman_msync.c
 */
#include <plc.h>
#include <sys/mman.h>


int PLEXPORT
msync(void *start, size_t len, int flags)
{
	PLSTATUS st;

	plenter_cancel_point();

        /* Flags are ignored, flush is always MS_SYNC */
	st = plsys_mmapflush((long)start, len);

	plleave_cancel_point();

	return ((st == PLSTATUS_SUCCESS) ? 0 : -1);
}


