/**
 * @file src/lib/plc/std/sys_select_select.c
 */
#include <sys/select.h>


int PLEXPORT
select(int nfds, fd_set *rfds, fd_set *wfds, fd_set *efds, struct timeval *tout)
{
	int n;

	plenter_cancel_point();

	switch (plsys_select(&n, nfds, rfds, wfds, efds, tout)) {
	case PLSTATUS_SUCCESS:
	case PLSTATUS_TIMEOUT:
		break;
	default:
		n = -1;
	}

	plleave_cancel_point();

	return n;
}


