/**
 * @file src/lib/plc/std/sys_socket_connect.c
 */
#include <plc.h>
#include <sys/socket.h>


SOCKET PLEXPORT
connect(SOCKET sock, const struct sockaddr *addr, socklen_t len)
{
	PLSTATUS st;
	long cs;

	plenter_cancel_point();

	st = plsock_connect(&cs, (long)sock, addr, len);

	plleave_cancel_point();

	return ((st == PLSTATUS_SUCCESS) ? (SOCKET)cs : SOCKET_ERROR);
}


