/**
 * @file src/lib/plc/std/sys_socket_recvfrom.c
 */
#include <plc.h>
#include <sys/socket.h>


ssize_t PLEXPORT
recvfrom(SOCKET sock, void *buf, size_t len, int flags, struct sockaddr *from,
    socklen_t *fromlen)
{
	PLSTATUS st;
	size_t ret;

	plenter_cancel_point();

	st = plsock_recvfrom(&ret, (long)sock, buf, len, flags, from, fromlen);

	plleave_cancel_point();

	return ((ssize_t)((st == PLSTATUS_SUCCESS) ? ret : SOCKET_ERROR));
}


