/**
 * @file src/lib/plc/std/sys_socket_send.c
 */
#include <plc.h>
#include <sys/socket.h>


ssize_t PLEXPORT
send(SOCKET sock, const void *buf, size_t len, int flags)
{
	PLSTATUS st;
	size_t ret;

	plenter_cancel_point();

	st = plsock_send(&ret, (long)sock, buf, len, flags);

	plleave_cancel_point();

	return ((ssize_t)((st == PLSTATUS_SUCCESS) ? ret : SOCKET_ERROR));
}


