/**
 * @file src/lib/plc/std/sys_socket_sendto.c
 */
#include <plc.h>
#include <sys/socket.h>


ssize_t PLEXPORT
sendto(SOCKET sock, const void *buf, size_t len, int flags,
    const struct sockaddr *to, socklen_t tolen)
{
	PLSTATUS st;
	size_t ret;

	plenter_cancel_point();

	st = plsock_sendto(&ret, (long)sock, buf, len, flags, to, tolen);

	plleave_cancel_point();

	return ((ssize_t)((st == PLSTATUS_SUCCESS) ? ret : SOCKET_ERROR));
}


