/**
 * @file src/lib/plc/std/unistd_fork.c
 */
#include <unistd.h>

extern void (*plprepare_fork)();
extern void (*plparent_fork)();
extern void (*plchild_fork)();
 

pid_t PLEXPORT
fork()
{
	long pid;

	if (plprepare_fork != NULL) {
		plprepare_fork();
	}

	if (plsys_fork(&pid) == PLSTATUS_SUCCESS) {
		if (pid == 0) {
			/*
			 * Child.
			 */
			if (plchild_fork != NULL) {
				plchild_fork();
			}

			return 0;
		}

		/*
		 * Parent.
		 */
		if (plparent_fork != NULL) {
			plparent_fork();
		}

		return ((pid_t)pid);
	}

	return ((pid_t)-1);
}


