/**
 * @file src/lib/plc/std/unistd_getcwd.c
 */
#include <plc.h>

#include <limits.h>
#include <stdlib.h>


char PLEXPORT *
getcwd(char *dst, size_t dstsiz)
{
	int alloc;

	alloc = 0;

	if (dst == NULL) {
		dst = malloc(PATH_MAX);
		if (dst == NULL) {
			return NULL;
		}

		dstsiz = PATH_MAX;
		alloc = 1;
	}
		
	if (plsys_getcwd(dst, dstsiz) == PLSTATUS_SUCCESS) {
		return dst;
	}

	if (alloc) {
		free(dst);
	}

	return NULL;
}


