/**
 * @file src/lib/plc/std/unistd_write.c
 */
#include <unistd.h>


ssize_t PLEXPORT
write(int fd, const void *buf, size_t count)
{
	PLSTATUS st;
	size_t sent;

	plenter_cancel_point();

	st = plsys_write((long)fd, buf, count, &sent);

	plleave_cancel_point();

	return ((st == PLSTATUS_SUCCESS) ? (ssize_t)sent : -1);
}


