PLBASE=			../../../../../..
#PLDEBUG=		yes
#PLOPT=			yes

include ${PLBASE}/mk/base.mk

ARADDFILE=		../../plsys_${PLTARGET}

ifeq (${PLDEBUG}, yes)
CRT0=			crt0_debug.o
PLCRT0=			plcrt0_debug.o
else
CRT0=			crt0.o
PLCRT0=			plcrt0.o
endif

SRCS_S+=		crt0.S \
			plcrt0.S \
			_plsyscall.S \
			plsys__setjmp.S \
			plsys_sigaction_restorer.S \
			plsyscall.S

SRCS+=			plsys_access.c \
			plsys_chdir.c \
			plsys_chmod.c \
			plsys_close.c \
			plsys_dlopen.c \
			plsys_dlsym.c \
			plsys_dup2.c \
			plsys_execve.c \
			plsys_exit.c \
			plsys_fcntl.c \
			plsys_fdatasync.c \
			plsys_fork.c \
			plsys_fstat.c \
			plsys_fsync.c \
			plsys_ftruncate.c \
			plsys_lseek.c \
			plsys_lstat.c \
			plsys_getcwd.c \
			plsys_getdll.c \
			plsys_gethostname.c \
			plsys_getnprocs.c \
			plsys_getpid.c \
			plsys_gettimeofday.c \
			plsys_getsymbol.c \
			plsys_getsymbol_any.c \
			plsys_gettid.c \
			plsys_init.c \
			plsys_ioctl.c \
			plsys_kill.c \
			plsys_mkdir.c \
			plsys_memmove.c \
			plsys_memset.c \
			plsys_mmapfile.c \
			plsys_mmapflush.c \
			plsys_ms2timespec.c \
			plsys_msleep.c \
			plsys_munmap.c \
			plsys_open.c \
			plsys_opendir.c \
			plsys_pipe.c \
			plsys_plmflags2prot.c \
			plsys_poll.c \
			plsys_read.c \
			plsys_readlink.c \
			plsys_release.c \
			plsys_rename.c \
			plsys_rmdir.c \
			plsys_schedyield.c \
			plsys_select.c \
			plsys_setsid.c \
			plsys_sigaction.c \
			plsys_sigaddset.c \
			plsys_sigdelset.c \
			plsys_sigemptyset.c \
			plsys_sigfillset.c \
			plsys_sigismember.c \
			plsys_sigsuspend.c \
			plsys_stat.c \
			plsys_texit.c \
			plsys_tfork.c \
			plsys_time.c \
			plsys_tkill.c \
			plsys_tsigmask.c \
			plsys_tsignal.c \
			plsys_tsigwait.c \
			plsys_twait.c \
			plsys_unlink.c \
			plsys_waitpid.c \
			plsys_write.c

SRCS+=			_plsys_palloc.c \
			_plsys_pfree.c \
			_plsys_mprotect.c \
			plsys_palloc.c \
			plsys_pfree.c \
			plsys_mprotect.c

SRCS+=			plsock_accept.c \
			plsock_bind.c \
			plsock_connect.c \
			plsock_close.c \
			plsock_getpeername.c \
			plsock_getsockname.c \
			plsock_getsockopt.c \
			plsock_init.c \
			plsock_listen.c \
			plsock_recv.c \
			plsock_recvfrom.c \
			plsock_recvmsg.c \
			plsock_send.c \
			plsock_sendto.c \
			plsock_sendmsg.c \
			plsock_setsockopt.c \
			plsock_shutdown.c \
			plsock_socket.c \
			plsock_socketpair.c

CPPFLAGS+=		-I../../../../../include
CLEANFILES+=		${ARADDFILE}

AROBJS=			${subst ${CRT0},,${subst ${PLCRT0},,${OBJS_ALL}}}

all: ${ARADDFILE} ${CRT0} ${PLCRT0}

include ${PLBASE}/mk/objtarget.mk

# FIXME this is hideous
${ARADDFILE}: ${AROBJS}
	echo ${+:%=sysdep/${PLOS}/${PLARCH}/%} > $@

include ${PLBASE}/mk/clean.mk

