/**
 * @file src/lib/plc/sysdep/freebsd/i386/_plsys_mprotect.c
 */
#include <plc.h>


PLSTATUS PLEXPORT
_plsys_mprotect(long *err, long addr, size_t size, PLMFLAGS flags)
{
	long val, error;

	val = _plsyscall(&error, SYS_mprotect, addr, size,
	    plsys_plmflags2prot(flags));
	if (val != -1) {
		return PLSTATUS_SUCCESS;
	}

	if (err != NULL) {
		*err = error;
	}

	return ((error == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


