/**
 * @file src/lib/plc/sysdep/freebsd/i386/_plsys_palloc.c
 */
#include <plc.h>


PLSTATUS PLEXPORT
_plsys_palloc(long *err, long *addr, unsigned long size, PLMFLAGS flags)
{
	long val, error;

	if (addr == NULL) {
		return PLSTATUS_INVALID;
	}

	/*
	 * caddr_t * mmap(caddr_t addr, size_t len, int prot,
	 *                int flags, int fd, off_t pos);
	 *
	 * Notice that off_t is a 64 bit value.
	 */
	val = _plsyscall(&error, SYS_mmap, 0, size, plsys_plmflags2prot(flags),
	    MAP_PRIVATE | MAP_ANONYMOUS, -1, (off_t)0);
	if (val != -1) {
		*addr = val;
		return PLSTATUS_SUCCESS;
	}

	if (err != NULL)  {
		*err = error;
	}

	return ((error == EAGAIN) ?  PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


