/**
 * @file lib/plc/sysdep/freebsd/i386/plcrt0.S
 * Peludo Libc - plcrt0.o
 * This file provides the start address (entry point) for the
 * main file in a PLD Chain.
 * <br>
 * Once a PLD Chain is loaded the kernel looks for the first module exporting
 * the <code>_plstart</code> function and calls it; when this function
 * returns the kernel unloads itself terminating the "peludo sesion".
 */

/*
 * int _plstart(int argc, char **argv)
 */
.text
.global _plstart
.extern _plsys_exit
.extern environ
.extern main

_plstart:	push	%ebp
		movl	%esp, %ebp
		movl	%ebp, _stack

		leal	_plend, %edx	// plsys_exit() should call _plend()
		movl	%edx, _plsys_exit

		xorl	%edx, %edx	// environment is NULL
		movl	%edx, environ

		movl	12(%ebp), %edx
		pushl	%edx
		movl	8(%ebp), %edx
		pushl	%edx
		leal	main, %edx	// Avoid unsupported R_386_PC32 reloc
		call	*%edx		// Call main(argc, argv)
		popl	%edx
		popl	%edx
		popl	%ebp
		ret

_plend:		popl	%eax
		popl	%eax
		movl	_stack, %ebp
		movl	%ebp, %esp
		popl	%ebp
		ret			// Return back to _plstart's caller

.data
_stack:		.long 0

