/**
 * @file src/lib/plc/sysdep/freebsd/i386/plsock_accept.c
 */
#include <plc.h>
#include <plsock.h>


PLSTATUS PLEXPORT
plsock_accept(long *asock, long sock, struct sockaddr *addr, socklen_t *len)
{
	long fd;

	if (asock == NULL) {
		return PLSTATUS_INVALID;
	}

	fd = plsyscall(SYS_accept, sock, addr, len);
	if (fd != -1) {
		*asock = fd;
		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


