/**
 * @file src/lib/plc/sysdep/freebsd/i386/plsock_connect.c
 */
#include <plc.h>
#include <plsock.h>


PLSTATUS PLEXPORT
plsock_connect(long *csock, long sock, const struct sockaddr *addr,
    socklen_t len)
{
	long fd;

	if (csock == NULL) {
		return PLSTATUS_INVALID;
	}

	fd = plsyscall(SYS_connect, sock, addr, len);
	if (fd != -1) {
		*csock = fd;
		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


