/**
 * @file src/lib/plc/sysdep/freebsd/i386/plsock_getpeername.c
 */
#include <plc.h>
#include <plsock.h>


PLSTATUS PLEXPORT
plsock_getpeername(long sock, struct sockaddr *addr, socklen_t *len)
{
	if (addr == NULL || len == NULL || *len == 0) {
		return PLSTATUS_INVALID;
	}

	if (plsyscall(SYS_getpeername, sock, addr, len) != -1) {
		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


