/**
 * @file src/lib/plc/sysdep/freebsd/i386/plsock_getsockopt.c
 */
#include <plc.h>
#include <plsock.h>


PLSTATUS PLEXPORT
plsock_getsockopt(long sock, int level, int optname, void *optval,
    socklen_t *optlen)
{
	if (plsyscall(SYS_getsockopt, sock, level, optname, optval, optlen)
	    != -1) {
		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


