/**
 * @file src/lib/plc/sysdep/freebsd/i386/plsock_recv.c
 */
#include <plc.h>
#include <plsock.h>


PLSTATUS PLEXPORT
plsock_recv(size_t *recv, long sock, void *buf, size_t len, int flags)
{
	long ret;

	ret = plsyscall(SYS_recvfrom, sock, buf, len, flags, 0, 0);
	if (ret != -1) {
		if (recv != NULL) {
			*recv = (size_t)ret;
		}
		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


