/**
 * @file src/lib/plc/sysdep/freebsd/i386/plsock_recvfrom.c
 */
#include <plc.h>
#include <plsock.h>


PLSTATUS PLEXPORT
plsock_recvfrom(size_t *recv, long sock, void *buf, size_t len, int flags,
    struct sockaddr *from, socklen_t *fromlen)
{
	long ret;

	ret = plsyscall(SYS_recvfrom, sock, buf, len, flags, from, fromlen);
	if (ret != -1) {
		if (recv != NULL) {
			*recv = (size_t)ret;
		}
		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


