/**
 * @file src/lib/plc/sysdep/freebsd/i386/plsock_recvmsg.c
 */
#include <plc.h>
#include <plsock.h>


PLSTATUS PLEXPORT
plsock_recvmsg(long *recv, long sock, struct msghdr *msg, int flags)
{
	long ret;

	ret = plsyscall(SYS_recvmsg, sock, msg, flags);
	if (ret != -1) {
		if (recv != NULL) {
			*recv = ret;
		}
		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


