/**
 * @file src/lib/plc/sysdep/freebsd/i386/plsock_send.c
 */
#include <plc.h>
#include <plsock.h>


PLSTATUS PLEXPORT
plsock_send(size_t *sent, long sock, const void *buf, size_t len, int flags)
{
	long ret;

	ret = plsyscall(SYS_sendto, sock, buf, len, flags, 0, 0);
	if (ret != -1) {
		if (sent != NULL) {
			*sent = (size_t)ret;
		}
		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


