/**
 * @file src/lib/plc/sysdep/freebsd/i386/plsock_sendmsg.c
 */
#include <plc.h>
#include <plsock.h>


PLSTATUS PLEXPORT
plsock_sendmsg(long *sent, long sock, const struct msghdr *msg, int flags)
{
	long ret;

	ret = plsyscall(SYS_sendmsg, sock, msg, flags);
	if (ret != -1) {
		if (sent != NULL) {
			*sent = ret;
		}
		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


