/**
 * @file src/lib/plc/sysdep/freebsd/i386/plsock_sendto.c
 */
#include <plc.h>
#include <plsock.h>


PLSTATUS PLEXPORT
plsock_sendto(size_t *sent, long sock, const void *buf, size_t len, int flags,
    const struct sockaddr *to, socklen_t tolen)
{
	long ret;

	ret = plsyscall(SYS_sendto, sock, buf, len, flags, to, tolen);
	if (ret != -1) {
		if (sent != NULL) {
			*sent = (size_t)ret;
		}
		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


