/**
 * @file src/lib/plc/sysdep/linux/i386/plsock_setsockopt.c
 */
#include <plc.h>
#include <plsock.h>


PLSTATUS PLEXPORT
plsock_setsockopt(long sock, int level, int optname, const void *optval,
    socklen_t optlen)
{
	if (plsyscall(SYS_setsockopt, sock, level, optname, optval, optlen)
	    != -1) {
		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


