/**
 * @file src/lib/plc/sysdep/freebsd/i386/plsock_socket.c
 */
#include <plc.h>
#include <plsock.h>


PLSTATUS PLEXPORT
plsock_socket(long *sock, int af, int type, int proto)
{
	long fd;

	if (sock == NULL) {
		return PLSTATUS_INVALID;
	}

	fd = plsyscall(SYS_socket, af, type, proto);
	if (fd != -1) {
		*sock = fd;
		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


