/**
 * @file src/lib/plc/sysdep/freebsd/i386/plsys_access.c
 */
#include <plc.h>


PLSTATUS PLEXPORT
plsys_access(const char *path, long mode)
{
	if (path == NULL) {
		return PLSTATUS_INVALID;
	}

	if (plsyscall(SYS_access, path, mode) == 0) {
		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


