/**
 * @file src/lib/plc/sysdep/freebsd/i386/plsys_chmod.c
 */
#include <plc.h>


/* XXX mode should be multiplatform */
PLSTATUS PLEXPORT
plsys_chmod(const char *path, long mode)
{
	if (path == NULL) {
		return PLSTATUS_INVALID;
	}

	if (plsyscall(SYS_chmod, path, mode) == 0) {
		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


