/**
 * @file src/lib/plc/sysdep/freebsd/i386/plsys_fcntl.c
 */
#include <plc.h>


PLSTATUS PLEXPORT
plsys_fcntl(long *result, long fd, long cmd, long arg)
{
	long ret;

	ret = plsyscall(SYS_fcntl, fd, cmd, arg);
	if (ret >= 0) {
		if (result != NULL) {
			*result = ret;
		}
		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


