/**
 * @file src/lib/plc/sysdep/freebsd/i386/plsys_gethostname.c
 */
#include <plc.h>


PLSTATUS PLEXPORT
plsys_uname(struct utsname *uname)
{
	if (uname == NULL) {
		return PLSTATUS_INVALID;
	}

	if (plsyscall(SYS_uname, &uname) != -1) {
		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


PLSTATUS PLEXPORT
plsys_gethostname(char *name, size_t size)
{
	struct utsname uname;
	PLSTATUS st;
	char *p;

	if ((st = plsys_uname(&uname)) != PLSTATUS_SUCCESS) {
		return st;
	}

	for (p = uname.nodename; size && p != '\0'; size--) {
		*name++ = *p++;
	}

	*name = '\0';

	return PLSTATUS_SUCCESS;
}


