/**
 * @file src/lib/plc/sysdep/freebsd/i386/plsys_lseek.c
 */
#include <plc.h>


PLSTATUS PLEXPORT
plsys_lseek(long *newoff, long fd, long offset, int whence)
{
	off_t off;

	off = plsyscall(SYS_lseek, fd, (off_t)offset, whence);
	if (off >= 0) {
		if (newoff != NULL) {
			*newoff = (long)off;
		}
		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


