/**
 * @file src/lib/plc/sysdep/freebsd/i386/plsys_mmapfile.c
 */
#include <plc.h>


PLSTATUS PLEXPORT
plsys_mmapfile(long *addr, long fd, size_t size, long flags, long prot,
    long offset)
{
	long ad;

	if (addr == NULL) {
		return PLSTATUS_INVALID;
	}

	/*
	 * caddr_t * mmap(caddr_t addr, size_t len, int prot,
	 *                int flags, int fd, off_t pos);
	 *
	 * Notice that off_t is a 64 bit value.
	 */
	ad = plsyscall(SYS_mmap, 0, size, prot, flags, fd, (off_t)offset);
	if (ad != -1) {
		*addr = ad;
	        return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


