/**
 * @file src/lib/plc/sysdep/freebsd/i386/plsys_open.c
 */
#include <plc.h>


PLSTATUS PLEXPORT
plsys_open(long *fd, const char *name, long flags, long mode)
{
	int rfd;

	if (fd == NULL || name == NULL) {
		return PLSTATUS_INVALID;
	}

	rfd = plsyscall(SYS_open, name, flags, mode);
	if (rfd != -1) {
		*fd = rfd;
		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


