/**
 * @file src/lib/plc/sysdep/freebsd/i386/plsys_palloc.c
 */
#include <plc.h>


PLSTATUS PLEXPORT
plsys_palloc(long *addr, size_t size, PLMFLAGS flags)
{
	if (addr == NULL) {
		return PLSTATUS_INVALID;
	}

	*addr = plsyscall(SYS_mmap, 0, size, plsys_plmflags2prot(flags),
	    MAP_PRIVATE | MAP_ANONYMOUS, -1, (off_t)0);

	if (*addr != -1) {
		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


