/**
 * @file src/lib/plc/sysdep/freebsd/i386/plsys_rename.c
 */
#include <plc.h>


PLSTATUS PLEXPORT
plsys_rename(const char *oldpath, const char *newpath)
{
	long ret;

	if (newpath == NULL || oldpath == NULL) {
		errno = EINVAL;
		return PLSTATUS_INVALID;
	}

	ret = plsyscall(SYS_rename, oldpath, newpath);
	return ((ret == 0) ? PLSTATUS_SUCCESS : PLSTATUS_FAILED);
}


