/**
 * @file src/lib/plc/sysdep/freebsd/i386/plsys_stat.c
 */
#include <plc.h>


PLSTATUS PLEXPORT
plsys_stat(const char *path, stat_t *st)
{
	if (path == NULL || st == NULL) {
		return PLSTATUS_INVALID;
	}

	if (plsyscall(SYS_stat, path, st) == 0) {
		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


