/**
 * @file src/lib/plc/sysdep/freebsd/i386/plsys_time.c
 */
#include <plc.h>


PLSTATUS PLEXPORT
plsys_time(time_t *time)
{
	struct timeval tv;

	if (plsyscall(SYS_gettimeofday, &tv, NULL) >= 0) {
		if (time != NULL) {
			*time = tv.tv_sec;
		}
		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


