/**
 * @file src/lib/plc/sysdep/freebsd/i386/plsys_tsigwait.c
 */
#include <plc.h>


PLSTATUS PLEXPORT
plsys_tsigwait(const sigset_t *set, int *signo)
{
	return PLSTATUS_NOT_IMPLEMENTED;
#if 0
	sigset_t realset;
	int signal;

	/*
	 * SIGCANCEL and SIGSETXID should not be blocked.
	 */
	if (set != NULL) {
		plsys_memmove(&realset, set, sizeof(realset));

		plsys_sigaddset(&realset, SIGCANCEL);
		plsys_sigaddset(&realset, SIGSETXID);

		set = &realset;
	}

	/*
	 * long sys_rt_sigtimedwait(
	 *		const sigset_t __user *uthese,
	 *		siginfo_t __user *uinfo,
	 *		const struct timespec __user *uts,
	 *		size_t sigsetsize
	 * );
	 *
	 * rt_sigtimedwait synchronously waits for queued signals specified in
	 * uthese. The uinfo value, if non-NULL, indicates to the call to
	 * return a structure of type siginfo_t containing information about
	 * the signal. The uts variable enables an upper bound on the time for
	 * when the process is suspended. sigsetsize should indicate the size
	 * of a sigset_t type.
	 */

	signal = plsyscall(SYS_rt_sigtimedwait, set, NULL, NULL, NSIG / 8, 0,
	    0);

	if (signal > 0) {
		if (signal == SIGCANCEL || signal == SIGSETXID) {
			/*
 			 * XXX
 			 * Because of the way sys_rt_sigtimedwait() works
 			 * if there exists a SIGCANCEL handler it was not
 			 * called and the thread was not terminated.
 			 * So we finish it here.
 			 */
			plexit(-1);
			/* NOTREACHED */
		}

		if (signo != NULL) {
			*signo = signal;
		}

		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
#endif
}


