/**
 * @file src/lib/plc/sysdep/linux/i386/_plsys_palloc.c
 */
#include <plc.h>


PLSTATUS PLEXPORT
_plsys_palloc(long *err, long *addr, unsigned long size, PLMFLAGS flags)
{
	long val, error;

	if (addr == NULL) {
		return PLSTATUS_INVALID;
	}

	val = _plsyscall(&error, SYS_mmap2, 0, size,
	    plsys_plmflags2prot(flags), MAP_PRIVATE | MAP_ANONYMOUS, -1, 0);
	if (val != -1) {
		*addr = val;
		return PLSTATUS_SUCCESS;
	}

	if (err != NULL) {
		*err = error;
	}

	return ((error == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


