/**
 * @file src/lib/plc/sysdep/linux/i386/_plsys_pfree.c
 */
#include <plc.h>


PLSTATUS PLEXPORT
_plsys_pfree(long *err, long addr, size_t size)
{
	long val, error;

	val = _plsyscall(&error, SYS_munmap, addr, size, 0, 0, 0, 0);
	if (val != -1) {
		return PLSTATUS_SUCCESS;
	}

	if (err != NULL) {
		*err = error;
	}

	return ((error == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


