/**
 * @file src/lib/plc/sysdep/linux/i386/plsock_accept.c
 */
#include <plc.h>
#include <plsock.h>


PLSTATUS PLEXPORT
plsock_accept(long *asock, long sock, struct sockaddr *addr, socklen_t *len)
{
	long args[3], fd;

	if (asock == NULL) {
		return PLSTATUS_INVALID;
	}

	args[0] = sock;
	args[1] = (long)addr;
	args[2] = (long)len;

	fd = plsyscall(SYS_socketcall, SOCKETCALL_ACCEPT, args, 0, 0, 0, 0);
	if (fd != -1) {
		*asock = fd;
		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


