/**
 * @file src/lib/plc/sysdep/linux/i386/plsock_bind.c
 */
#include <plc.h>
#include <plsock.h>


PLSTATUS PLEXPORT
plsock_bind(long sock, const struct sockaddr *addr, socklen_t len)
{
	long args[3];

	args[0] = sock;
	args[1] = (long)addr;
	args[2] = (long)len;

	if (plsyscall(SYS_socketcall, SOCKETCALL_BIND, args, 0, 0, 0, 0) != -1)
		return PLSTATUS_SUCCESS;

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


