/**
 * @file src/lib/plc/sysdep/linux/i386/plsock_connect.c
 */
#include <plc.h>
#include <plsock.h>


PLSTATUS PLEXPORT
plsock_connect(long *csock, long sock, const struct sockaddr *addr,
    socklen_t len)
{
	long args[3], fd;

	if (csock == NULL) {
		return PLSTATUS_INVALID;
	}

	args[0] = sock;
	args[1] = (long)addr;
	args[2] = (long)len;

	fd = plsyscall(SYS_socketcall, SOCKETCALL_CONNECT, args, 0, 0, 0, 0);
	if (fd != -1) {
		*csock = fd;
		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


