/**
 * @file src/lib/plc/sysdep/linux/i386/plsock_listen.c
 */
#include <plc.h>
#include <plsock.h>


PLSTATUS PLEXPORT
plsock_listen(long sock, int backlog)
{
	long args[2];

	args[0] = sock;
	args[1] = (long)backlog;

	if (plsyscall(SYS_socketcall, SOCKETCALL_LISTEN, args, 0, 0, 0, 0)
	    != -1) {
		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


