/**
 * @file src/lib/plc/sysdep/linux/i386/plsock_recvfrom.c
 */
#include <plc.h>
#include <plsock.h>


PLSTATUS PLEXPORT
plsock_recvfrom(size_t *recv, long sock, void *buf, size_t len, int flags,
    struct sockaddr *from, socklen_t *fromlen)
{
	long args[6], ret;

	args[0] = sock;
	args[1] = (long)buf;
	args[2] = (long)len;
	args[3] = (long)flags;
	args[4] = (long)from;
	args[5] = (long)fromlen;

	ret = plsyscall(SYS_socketcall, SOCKETCALL_RECVFROM, args, 0, 0, 0, 0);
	if (ret != -1) {
		if (recv != NULL) {
			*recv = (size_t)ret;
		}
		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


