/**
 * @file src/lib/plc/sysdep/linux/i386/plsock_send.c
 */
#include <plc.h>
#include <plsock.h>


PLSTATUS PLEXPORT
plsock_send(size_t *sent, long sock, const void *buf, size_t len, int flags)
{
	long args[4], ret;

	args[0] = sock;
	args[1] = (long)buf;
	args[2] = (long)len;
	args[3] = (long)flags;

	ret = plsyscall(SYS_socketcall, SOCKETCALL_SEND, args, 0, 0, 0, 0);
	if (ret != -1) {
		if (sent != NULL) {
			*sent = (size_t)ret;
		}
		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


