
#include <plc.h>
#include <plsock.h>


PLSTATUS PLEXPORT
plsock_sendmsg(long *sent, long sock, const struct msghdr *msg, int flags)
{
	long args[3], ret;

	args[0] = sock;
	args[1] = (long)msg;
	args[2] = (long)flags;

	ret = plsyscall(SYS_socketcall, SOCKETCALL_SENDMSG, args, 0, 0, 0, 0);
	if (ret != -1) {
		if (sent != NULL) {
			*sent = ret;
		}
		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


