/**
 * @file src/lib/plc/sysdep/linux/i386/plsock_sendto.c
 */
#include <plc.h>
#include <plsock.h>


PLSTATUS PLEXPORT
plsock_sendto(size_t *sent, long sock, const void *buf, size_t len, int flags,
    const struct sockaddr *to, socklen_t tolen)
{
	long args[5], ret;

	args[0] = sock;
	args[1] = (long)buf;
	args[2] = (long)len;
	args[3] = (long)flags;
	args[4] = (long)to;
	args[5] = (long)tolen;

	ret = plsyscall(SYS_socketcall, SOCKETCALL_SENDTO, args, 0, 0, 0, 0);
	if (ret != -1) {
		if (sent != NULL) {
			*sent = (size_t)ret;
		}
		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


