/**
 * @file src/lib/plc/sysdep/linux/i386/plsock_setsockopt.c
 */
#include <plc.h>
#include <plsock.h>


PLSTATUS PLEXPORT
plsock_setsockopt(long sock, int level, int optname, const void *optval,
    socklen_t optlen)
{
	long args[5];

	args[0] = sock;
	args[1] = (long)level;
	args[2] = (long)optname;
	args[3] = (long)optval;
	args[4] = (long)optlen;

	if (plsyscall(SYS_socketcall, SOCKETCALL_SETSOCKOPT, args, 0, 0, 0, 0)
	    != -1) {
		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


