/**
 * @file src/lib/plc/sysdep/linux/i386/plsock_shutdown.c
 */
#include <plc.h>
#include <plsock.h>


PLSTATUS PLEXPORT
plsock_shutdown(long sock, int how)
{
	long args[2];

	args[0] = sock;
	args[1] = (long)how;

	if (plsyscall(SYS_socketcall, SOCKETCALL_SHUTDOWN, args, 0, 0, 0, 0)
	    != -1) {
		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


