/**
 * @file src/lib/plc/sysdep/linux/i386/plsock_socket.c
 */
#include <plc.h>
#include <plsock.h>


PLSTATUS PLEXPORT
plsock_socket(long *sock, int af, int type, int proto)
{
	long fd, args[3];

	if (sock == NULL) {
		return PLSTATUS_INVALID;
	}

	args[0] = (long)af;
	args[1] = (long)type;
	args[2] = (long)proto;

	fd = plsyscall(SYS_socketcall, SOCKETCALL_SOCKET, args, 0, 0, 0, 0);
	if (fd != -1) {
		*sock = fd;
		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


