/**
 * @file src/lib/plc/sysdep/linux/i386/plsys_fstat.c
 */
#include <plc.h>


PLSTATUS PLEXPORT
plsys_fstat(long fd, stat_t *st)
{
	if (st == NULL) {
		return PLSTATUS_INVALID;
	}

	if (plsyscall(SYS_fstat, fd, st, 0, 0, 0, 0) == 0) {
		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


