/**
 * @file src/lib/plc/sysdep/linux/i386/plsys_getsymbol_any.c
 * Resolve a symbol traversing the DLL export table.
 *
 * @todo Support for 64 bit ELF
 */
#include <plc.h>


/**
 * Get the address of a symbol exported by any loaded DLL.
 * Traverse all loaded DLLs export tables searching for the desired symbol,
 * stops when some DLL exports them.
 *
 * @param base (IN) DLL base address;
 * @param symname (IN) Symbol name (asciiz).
 *
 * @return If the symbol is found its virtual address is returned;
 * otherwise 0 is returned.
 *
 * @see plsys_getdll()
 * @see plsys_getsymbol()
 *
 * FIXME Implement
 */
long PLEXPORT
plsys_getsymbol_any(const char *symname)
{
	return PLSTATUS_NOT_IMPLEMENTED;
}


