/**
 * @file src/lib/plc/sysdep/linux/i386/plsys_lseek.c
 */
#include <plc.h>


PLSTATUS PLEXPORT
plsys_lseek(long *newoff, long fd, long offset, int whence)
{
	long off;

	off = plsyscall(SYS_lseek, fd, offset, whence, 0, 0, 0);
	if (off >= 0) {
		if (newoff != NULL) {
			*newoff = off;
		}
		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


