/**
 * @file src/lib/plc/sysdep/linux/i386/plsys_lstat.c
 */
#include <plc.h>


PLSTATUS PLEXPORT
plsys_lstat(const char *path, stat_t *st)
{
	if (path == NULL || st == NULL) {
		return PLSTATUS_INVALID;
	}

	if (plsyscall(SYS_lstat, path, st, 0, 0, 0, 0) == 0) {
		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


