
#include <plc.h>


void PLEXPORT *
plsys_memmove(void *dst, const void *src, size_t siz)
{
	if (src > dst) {
		asm __volatile__(
	    	    "	pushl	%%ecx		\n"
	    	    "	pushl	%%esi		\n"
	    	    "	pushl	%%edi		\n"
		    "	movl	%0, %%ecx	\n"
		    "	movl	%1, %%esi	\n"
		    "	movl	%2, %%edi	\n"
		    "	cld			\n"
		    "	rep	movsb		\n"
	    	    "	popl	%%edi		\n"
	    	    "	popl	%%esi		\n"
	    	    "	popl	%%ecx		\n"
		    :: "g" (siz), "g" (src), "g" (dst));
	} else {
		long s = (long)src + siz - 1;
		long d = (long)dst + siz - 1;

		asm __volatile__(
	    	    "	pushl	%%ecx		\n"
	    	    "	pushl	%%esi		\n"
	    	    "	pushl	%%edi		\n"
		    "	movl	%0, %%ecx	\n"
		    "	movl	%1, %%esi	\n"
		    "	movl	%2, %%edi	\n"
		    "	std			\n"
		    "	rep	movsb		\n"
	    	    "	popl	%%edi		\n"
	    	    "	popl	%%esi		\n"
	    	    "	popl	%%ecx		\n"
		    :: "g" (siz), "g" (s), "g" (d));
	}

	return dst;
}


