/**
 * @file src/lib/plc/sysdep/linux/i386/plsys_mkdir.c
 */
#include <plc.h>


PLSTATUS PLEXPORT
plsys_mkdir(const char *path, long mode)
{
	if (path == NULL) {
		return PLSTATUS_INVALID;
	}

	if (plsyscall(SYS_mkdir, path, mode, 0, 0, 0, 0) == 0) {
		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


