/**
 * @file src/lib/plc/sysdep/linux/i386/plsys_mmapfile.c
 */
#include <plc.h>


PLSTATUS PLEXPORT
plsys_mmapfile(long *addr, long fd, size_t size, long flags, long prot,
    long offset)
{
	long ad;

	if (addr == NULL) {
		return PLSTATUS_INVALID;
	}

	ad = plsyscall(SYS_mmap2, 0, size, prot, flags, fd, offset);
	if (ad != -1) {
		*addr = ad;
	        return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


