/**
 * @file src/lib/plc/sysdep/linux/i386/plsys_poll.c
 */
#include <plc.h>


PLSTATUS PLEXPORT
plsys_poll(long *result, struct pollfd *fds, nfds_t nfds, int timeout)
{
	if (result == NULL || fds == NULL) {
		return PLSTATUS_INVALID;
	}

	*result = plsyscall(SYS_poll, fds, nfds, timeout, 0, 0, 0);
	if (*result != -1) {
		return ((*result == 0) ? PLSTATUS_TIMEOUT : PLSTATUS_SUCCESS);
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


