/**
 * @file src/lib/plc/sysdep/linux/i386/plsys_read.c
 */
#include <plc.h>


PLSTATUS PLEXPORT
plsys_read(long fd, void *buf, size_t size, size_t *rsiz)
{
	long rs;

	if (buf == NULL) {
		return PLSTATUS_INVALID;
	}

	if ((rs = plsyscall(SYS_read, fd, buf, size, 0, 0, 0)) != -1) {
		if (rsiz != NULL) {
			*rsiz = (ssize_t)rs;
		}
		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


