/**
 * @file src/lib/plc/sysdep/linux/i386/plsys_readlink.c
 */
#include <plc.h>


PLSTATUS PLEXPORT
plsys_readlink(const char *path, char *buf, long *bufsiz)
{
	long rs;

	if (path == NULL || buf == NULL || bufsiz == NULL) {
		return PLSTATUS_INVALID;
	}

	if ((rs = plsyscall(SYS_readlink, path, buf, bufsiz, 0, 0, 0)) != -1) {
		*bufsiz = rs;
		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


