/**
 * @file src/lib/plc/sysdep/linux/i386/plsys_select.c
 */
#include <plc.h>


PLSTATUS PLEXPORT
plsys_select(int *ready, int fds, fd_set *rfd, fd_set *wfd, fd_set *efd,
    struct timeval *to)
{
	long res;

	if (ready == NULL) {
		return PLSTATUS_INVALID;
	}

	res = plsyscall(SYS__newselect, fds, rfd, wfd, efd, to, 0);
	if (res != -1) {
		*ready = res;
		return ((res == 0) ? PLSTATUS_TIMEOUT : PLSTATUS_SUCCESS);
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


