/**
 * @file src/lib/plc/sysdep/linux/i386/plsys_write.c
 */
#include <plc.h>


PLSTATUS PLEXPORT
plsys_write(long fd, const void *buf, size_t size, size_t *wsiz)
{
	long rs;

	if (buf == NULL) {
		return PLSTATUS_INVALID;
	}

	if ((rs = plsyscall(SYS_write, fd, buf, size, 0, 0, 0)) != -1) {
		if (wsiz != NULL) {
			*wsiz = (size_t)rs;
		}
		return PLSTATUS_SUCCESS;
	}

	return ((errno == EAGAIN) ? PLSTATUS_TRY_AGAIN : PLSTATUS_FAILED);
}


