/**
 * @file src/lib/plc/sysdep/linux/i386/plsyscall.S
 */
.text
.global plsyscall
.extern plgeterrno


#define ARG_0		0x1C
#define ARG_1		0x20
#define ARG_2		0x24
#define ARG_3		0x28
#define ARG_4		0x2C
#define ARG_5		0x30
#define ARG_6		0x34


/*
 * long plsyscall(long sysno,
 *                long a1, long a2, long a3, long a4, long a5, long a6)
 *
 * On Linux-i386 this function requires 6 arguments,
 * no matter whether the syscall called uses them or not.
 */
plsyscall:	pushl	%ebx
		pushl	%ecx
		pushl	%edx
		pushl	%esi
		pushl	%edi

		pushl	%ebp
		movl	%esp, %ebp

		movl	ARG_0(%ebp), %eax
		movl	ARG_1(%ebp), %ebx
		movl	ARG_2(%ebp), %ecx
		movl	ARG_3(%ebp), %edx
		movl	ARG_4(%ebp), %esi
		movl	ARG_5(%ebp), %edi
		movl	ARG_6(%ebp), %ebp
		int 	$0x80

		cmpl	$-4095, %eax
		jb	plsyscall_end

		negl	%eax
		movl	%eax, %ebx
		call	*(plgeterrno)
		movl	%ebx, (%eax)

		xorl	%eax, %eax
		decl	%eax

plsyscall_end:	popl	%ebp
		popl	%edi
		popl	%esi
		popl	%edx
		popl	%ecx	
		popl	%ebx
		ret

