
#include <plc.h>

#include <dirent.h>
#include <stdio.h>
#include <string.h>


static void pldir(const char *path)
{
	struct dirent *de;
	long handle;
	PLSTATUS st;

	st = plsys_opendir(&handle, path);
	if (st != PLSTATUS_SUCCESS) {
		plprint("Can't plsys_opendir: %s", plstrstatus(st));
		return;
	}

	while (1) {
		st = plsys_readdir(handle, &de);
		if (st == PLSTATUS_SUCCESS) {
			plprint("\t%s\n", de->d_name);

		} else if (st == PLSTATUS_EOF) {
			break;

		} else {
			plprint("Can't plsys_readdir: %s - errno = %d\n",
			    plstrstatus(st), errno);
			break;

		}
	}

	plsys_closedir(handle);
}


static void dir(const char *path)
{
	struct dirent *de;
	DIR *dir;

	dir = opendir(path);
	if (dir == NULL) {
		fprintf(stderr, "Can't opendir: %s", strerror(errno));
		return;
	}

	while ((de = readdir(dir)) != NULL) {
		fprintf(stdout, "\t%s\n", de->d_name);
	}

	closedir(dir);
}


int
main(int argc, char **argv)
{
	plinit();

	if (argc != 2) {
		plprint("pldir <dir>\n");
		return -1;
	}

	// peludo api
	if (0) 
		pldir(argv[1]);

	// posix api
	if (1)
		dir(argv[1]);

	plrelease();
	return 0;
}


