
#include <plc.h>
#include <pllog.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>


int
main(int argc, char **argv)
{
	PLSTATUS st;
	long pid;
	pid_t p;

	plinit();

	pldebug("Creating a new process using plsys_fork()...\n");
	st = plsys_fork(&pid);
	if (pid != 0) {
		pldebug("Result=%s. Pid of new process is %d\n", plstrstatus(st), pid);
	} else {
		plsys_msleep(100);
		pldebug("Hi!, I am the child created using plsys_fork(). "
		    "I'll terminate in 2 seconds\n");
		plsys_msleep(2000);
		goto bye;
	}

	plsys_msleep(500);
	pldebug("Creating a new process using fork()...\n");
	p = fork();
	if (p != 0) {
		pldebug("Pid of new process is %d\n", p);
	} else {
		plsys_msleep(100);
		pldebug("Hi!, I am the child created using fork(). "
		    "I'll terminate in 2 seconds\n");
		plsys_msleep(2000);
		goto bye;
	}

	plsys_msleep(500);
	pldebug("Parent is sleeping for 1 second then terminate...\n");
	plsys_msleep(1000);

bye:	plrelease();
	return 0;
}


