
#include <plc.h>

#include <dirent.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>


static void plpwd()
{
	char buf[1024], *p;
	PLSTATUS st;

	if ((st = plsys_getcwd(buf, sizeof(buf))) == PLSTATUS_SUCCESS) {
		printf("plsys api: %s\n", buf);
	} else {
		printf("plsys api failed: %s, errno=%d\n", plstrstatus(st), errno);
	}

	if (getcwd(buf, sizeof(buf)) != NULL) {
		printf("posix api: %s\n", buf);
	} else {
		printf("posix api failed: %d-%s\n", errno, strerror(errno));
	}

	if ((p = getcwd(NULL, 0)) != NULL) {
		printf("posix api with malloc: %s\n", p);
		free(p);
	} else {
		printf("posix api with malloc failed: %d-%s\n", errno, strerror(errno));
	}
}


int
main(int argc, char **argv)
{
	plinit();

	plpwd();

	plrelease();

	return 0;
}


