#!/bin/sh

cat $@ | sort | awk '\
	BEGIN {
		total_time = 0
		total_count = 0
		total_symbols = 0
		last_symbol = ""
	}{
		total_count++
		total_time += $3
		if (last_symbol != $1) {
			last_symbol = $1
			symbol[total_symbols] = $1
			total_symbols++
		}
		count[$1]++
		elapsed[$1] += $3

	} END {
		printf("Calls Executed: %lu\n", total_count)
		printf("Symbols Executed: %lu\n", total_symbols)
		printf("Total time: %luus\n", total_time)

		printf("Summary:\n")

		for (i = 0; i < total_symbols; i++) {
			sym = symbol[i]
			printf("Symbol %s executed %lu times (%f%%), time consumed %luus (%f%%)\n",
			    sym, count[sym], 100 * count[sym] / total_count,
			    elapsed[sym], 100 * elapsed[sym] / total_time)
		}
	}'

