/**
 * @file src/lib/pthread/init.c
 * Peludo Threads - Module initialization and finalization.
 */
#include <plc.h>
#include <pthread.h>


/**
 * Initialize the pthread library.
 * Called by the Peludo Kernel when the pthread library is loaded.
 *
 * @see PLSTATUS
 * @see _fini()
 * @see pthread_init_np()
 */
PLSTATUS PLEXPORT
_init()
{
	return pthread_init_np();
}


/**
 * Release the pthread library.
 * Called by the Peludo Kernel when the pthread library is unloaded.
 *
 * @see _init()
 * @see pthread_release_np()
 */
void PLEXPORT
_fini()
{
	pthread_release_np();
}


