PLBASE=			../../../../../..
override PLDEBUG=	no

include ${PLBASE}/mk/base.mk

LIB=		exec_elf32_${PLTARGET}
ENCODED=	${LIB}.data
SRC=		${LIB}.S
OBJ=		${LIB}.o

CLEANFILES+=	${ENCODED} \
		${LIB} \
		${OBJ}

.PHONY: all

all: ${ENCODED}

${ENCODED}: ${LIB}
	${OPENSSL} enc -e -base64 -in $< -out $@

${LIB}: ${OBJ}
	${OBJCOPY} -O binary -j .text $< $@
	${CHMOD} +x $@

${OBJ}: ${SRC}
	${CC} -m32 -nostdlib -c -O0 -o $@ $<

include ${PLBASE}/mk/install.mk
include ${PLBASE}/mk/clean.mk

